{$I strings.inc}
{$I snow.inc}

const
 BoxNormal      :Byte =   $00;
 BoxShadow      :Byte =   $01;
 BoxThick       :Byte =   $02;
 BoxIn          :Byte =   $10;
 BoxOut         :Byte =   $20;
 BoxInOut       :Byte =   $30;

var
 SC:Array[0..7] Of BoxType;
 TimeTick:longint absolute $0040:$006C;
 IsMain:boolean;
 C:char;

procedure BoxStyleInit;
begin
 SC[0].Hi:=     $09;
 SC[0].Med:=    $01;
 SC[0].Lo:=     $08;
 SC[0].Back:=   $01;
 SC[0].State:=  BoxOut+BoxThick;
 SC[1].Hi:=     $08;
 SC[1].Med:=    $01;
 SC[1].Lo:=     $09;
 SC[1].Back:=   14;
 SC[1].Shadow:= $00;
 SC[1].State:=  BoxIn+BoxShadow+BoxThick;
 SC[2].Hi:=     $0B;
 SC[2].Med:=    $00;
 SC[2].Lo:=     $00;
 SC[2].Back:=   $03;
 SC[2].State:=  BoxOut+BoxThick;
 SC[3].Hi:=     $0F;
 SC[3].Med:=    $07;
 SC[3].Lo:=     $08;
 SC[3].Back:=   $07;
 SC[3].Shadow:= $00;
 SC[3].State:=  BoxInOut+BoxShadow+BoxThick;
 SC[4].Hi:=     $0D;
 SC[4].Med:=    $00;
 SC[4].Lo:=     $00;
 SC[4].Back:=   5;
 SC[4].State:=  BoxOut+BoxThick;
 SC[5].Hi:=     $0F;
 SC[5].Med:=    $07;
 SC[5].Lo:=     $08;
 SC[5].Back:=   55;
 SC[5].Shadow:= $00;
 SC[5].State:=  BoxOut+BoxThick;
 SC[6].Hi:=     $0F;
 SC[6].Med:=    $08;
 SC[6].Lo:=     $08;
 SC[6].Back:=   100;
 SC[6].Shadow:= $00;
 SC[6].State:=  BoxOut+BoxThick;
 SC[7].Hi:=     $0F;
 SC[7].Med:=    $08;
 SC[7].Lo:=     $08;
 SC[7].Back:=   80;
 SC[7].Shadow:= $00;
 SC[7].State:=  BoxIn+BoxThick;
end;

procedure VideoOff(T:boolean); assembler;
asm
  mov ah,12h        { BIOS function }
  mov al,T          { 0 = on, 1 = off }
  mov bl,36h        { Subfunction }
  int 10h           { Call BIOS }
end;

procedure SetHangul(W,H:byte);
begin
  FontStyle.Width:=W;
  FontStyle.Height:=H;
end;

procedure Done;
begin
  HanDone;
  SetMode(_TextMode);
end;

procedure ClearScreen1;
var T:word;
begin
  for T:=0 to 479 do
    if T mod 2=0 then Line(0,T,639,T,0);
  for T:=0 to 639 do
    if T mod 2=0 then Line(T,0,T,479,0);
  for T:=479 downto 0 do
    if T mod 2=1 then Line(0,T,639,T,0);
end;

procedure ClearScreen2;
var B:boxtype;
    x,y:byte;
begin
  b.hi:=0;
  b.med:=0;
  b.lo:=0;
  b.shadow:=0;
  b.back:=0;
  for x:=0 to 9 do
    for y:=0 to 9 do begin
      box(x*64,y*48,x*64+64,y*48+48,b);
      delay(2)
    end
end;

procedure GCLS;
begin
  randomize;
  if random(2)=0 then ClearScreen1 else ClearScreen2
end;

procedure ViewPCX(S:string;C:boolean);
var T:byte;
begin
  if C then GCLS;
  VideoOff(true);
  Pcxslow(S,0,0,0,0,640,480,Palette);
  Save_In_Out;
  for T:=0 to 10 do fade_in_out(-1);
  VideoOff(false);
  for T:=0 to 10 do begin
    delay(50);
    fade_in_out(1);
  end;
  Recover;
end;

procedure HWrite(Inp:MT);
begin
  with Inp do begin
    FontStyle.Color:=C;
    FontStyle.Bcolor:=B;
    PutText(X*8,Y*19,D,S);
    delay(D2);
  end;
end;

procedure AutoPause(S:byte);
var T:longint;
begin
  T:=TimeTick;
  repeat
    if abs(T-Timetick)=18*S then exit
  until fkeypressed;
  clearkeybuffer
end;

{$F+}
procedure WarmBootError;
var S:MT;
begin
  if IsMain then begin
    Box(160,280,472,350,SC[6]);
    S.X:=28;
    S.Y:=16;
    S.C:=15;
    S.B:=8;
    S.D:=0;
    S.D2:=0;
    S.S:='˷ w wá. A~';
    HWrite(S);
    AutoPause(1);
    Box(160,280,472,350,SC[4])
  end else begin
    sound(3000);
    delay(100);
    nosound;
    delay(100);
    sound(5000);
    delay(100);
    nosound
  end
end;
{$F-}

procedure Init;
var T:byte;
begin
  randomize;
  for T:=1 to Numberofsnow do new(S[T],Init);
  for T:=1 to Numberofsnow-50 do new(S2[T],Init);
  for T:=1 to Numberofsnow-100 do new(S3[T],Init);

  setcbreak(false);
  checkbreak:=false;
  SetBreak(false);
  SetBoot(false);
  KC_Handler:=WarmBootError;
  HanInit;
  SetMode(_640x480Mode);
  BoxStyleInit;
  SetHangul(2,2)
end;

procedure Want(C,B:byte);
begin
  SetHangul(1,1);
  FontStyle.Color:=C;
  FontStyle.Bcolor:=B;
  PutText(0,465,0,'ae ѡ ǡi e Aa!');
end;

procedure Wait(C,B:byte);
var T:byte;
begin
  SetHangul(1,1);
  FontStyle.Color:=C;
  FontStyle.Bcolor:=B;
  PutText(0,465,0,'aǡa aAw!');
  AutoPause(20);
  Save_In_Out;
  for T:=0 to 63 do begin
    fade_in_out(-1);
    delay(10)
  end;
  ClearScreen(0);
  Recover
end;

function Inkey:char;
var T:char;
    TT:longint;
begin
  mem[0:$41A]:=mem[0:$41C];
  TT:=TimeTick;
  repeat
    if IsMain then PlaySnow;
    if abs(TT-Timetick)=18*25 then exit
  until fkeypressed;
  T:=readkey;
  if T=#0 then T:=readkey;
  Inkey:=T;
end;

procedure Message(Inp:MT);
begin
  with Inp do begin
    Box(X*8,Y*19,X*8+(succ(length(S))*8),Y*19+38,SC[0]);
    FontStyle.Color:=C;
    FontStyle.Bcolor:=B;
    PutText(X*8+4,Y*19+4,D,S);
    delay(D2);
  end;
end;

procedure Push(Inp:MT);
var T:byte;
begin
  with Inp do
    for T:=1 to 3 do begin
      Box(X*8,Y*19,X*8+(succ(length(S))*8),Y*19+38,SC[T mod 2]);
      FontStyle.Color:=C;
      FontStyle.Bcolor:=SC[T mod 2].Back;
      PutText(X*8+4,Y*19+4,0,S);
      delay(90);
    end;
end;
