{$X+}

Uses Crt,Dos,Svga2;
Const
 DiLeft :Byte =$01;
 DiMed  :Byte =$02;
 DiRight:Byte =$04;

Type
 DiType=Record
         Hi,Med,Lo,Shadow,Back:Byte;
         State:Byte;
         Title:Byte;
         TPos:Byte;
         TWidth:Byte;
         THi,TMed,TLo,TBack:Byte;
        End;

Var
 I,J,K,L:Word;
 Ka1,Ka2:Char;
 FName:String;
 S1,S2:String;

 ViewMaxY:Byte;
 Mode:Byte;

 T1,T2,T3,T4:Byte;

 PeExit:Boolean;
 ReDr:Boolean;
 C1,C2,C3:Byte;
 ReSr:Boolean;

 DiBox:DiType;

 _417:Byte Absolute $0000:$0417;

 He:Array[0..$FF] Of Byte;
 BD:Array[0..$FF] Of BoxType;
 SC:Array[0..12] Of BoxType;
 ColS:Array[0..$100] Of Byte;
 AD:Array[0..$100] Of Word;
 ColN,EX,EY,FY:Word;
 SelC:ArrAy[0..1] Of Byte;

 _LRGB:Array[0..3] Of Byte;


Procedure DrawDi(X1,Y1,X2,Y2:Word; Title:String; BoxCol:DiType);
Var
 B:BoxType;
 I:Word;
Begin
 Move(BoxCol,B,6);
 B.State:=B.State Or BoxInOut;
 Box(X1,Y1,X2,Y2,B);
 Move(BoxCol.THi,B,3);
 B.Back:=BoxCol.TBack;
 B.State:=BoxOut;
 Box(X1+6,Y1+4,X2-7,Y1+22,B);
 FontStyle.Color:=BoxCol.Title;
 FontStyle.BColor:=BoxCol.TBack;
 FontStyle.Width:=BoxCol.TWidth;
 Case BoxCol.TPos Of
  1:I:=X1+8;
  2:I:=X1+((X2-X1) Shr 1)-((Ord(Title[0])*BoxCol.TWidth) Shl 2);
  4:I:=X2-8-((Ord(Title[0])*BoxCol.TWidth) Shl 3);
 End;
 PutText(I,Y1+5,Title);
End;

Procedure ReadPePal(name:String);
Var
 F:File;
Begin
 Assign(F,Name);
 Reset(F,1);
 BlockRead(F,Palette,768);
 If FileSize(F)=1280 Then
  Begin
   BlockRead(F,He,256);
   BlockRead(F,ColS,$100);
  End;
 Close(F);
End;

Procedure FindSel(Var I,J:Word);
Begin
 If SelC[0]>SelC[1] Then Begin I:=SelC[1]; J:=SelC[0]; End
  Else Begin I:=SelC[0]; J:=SelC[1]; End;
End;

Procedure FindEnd(Var Ey,Fy:Word);
Var
 I:Word;
Begin
 I:=$100;
 Repeat
  Dec(I);
 Until (Cols[I]>0) And (Cols[I+1]=0);
 If I>ViewMaxY Then
   Begin
    Ey:=ViewMaxY; Fy:=I-ViewMaxY;
   End
  Else
   Begin
    Ey:=I; Fy:=0;
   End;
End;

Procedure FindEndColS(Var I:Word);
Begin
 I:=$100;
 Repeat
  Dec(I);
 Until (Cols[I]>0);
End;

Procedure UnSelectCol;
Var
 I,J,K:Word;
Begin
 FindSel(J,K);
 For I:=J To K Do
  BD[I].State:=BoxOut;
 BD[ColN].State:=BoxInOut;
End;

Procedure SelectCol;
Var
 I,J,K:Word;
Begin
 FindSel(J,K);
 For I:=J To K Do
  BD[I].State:=BoxThick + BoxIn;
 BD[ColN].State:=BoxInOut;
End;

Procedure UnColN;
Var
 I,J:Word;
Begin
 FindSel(I,J);
 If (I<=ColN) And (ColN<=J) Then BD[ColN].State:=BoxThick+BoxIn
  Else BD[ColN].State:=BoxOut;
End;

Procedure DelColS(Y:Word);
Begin
 If ColS[Y]=0 Then
  Begin
   Move(ColS[Y+1],ColS[Y],255-Y+1);
   ColS[255]:=0;
  End;
End;

Procedure InsColS(Y:Word);
Var
 D:Array[0..255] Of Byte;
Begin
 Move(ColS[Y],D,255-Y+1);
 Move(D,ColS[Y+1],255-Y);
 ColS[Y]:=0;
End;

Procedure WritePePal(name:String);
Var
 F:File;
Begin
 Assign(F,Name);
 Rewrite(F,1);
 BlockWrite(F,Palette,768);
 BlockWrite(F,He,256);
 BlockWrite(F,ColS,$100);
 Close(F);
End;

Procedure Init;
Var
 I:Word;
Begin
 SC[0].Hi:=     $0C;
 SC[0].Med:=    $00;
 SC[0].Lo:=     $00;
 SC[0].Back:=   $04;
 SC[0].State:=  BoxOut;
 SC[1].Hi:=     $09;
 SC[1].Med:=    $01;
 SC[1].Lo:=     $08;
 SC[1].Back:=   $01;
 SC[1].Shadow:= $00;
 SC[1].State:=  BoxInOut+BoxShadow;
 SC[2].Hi:=     $0B;
 SC[2].Med:=    $00;
 SC[2].Lo:=     $00;
 SC[2].Back:=   $03;
 SC[2].State:=  BoxOut;
 SC[3].Hi:=     $0F;
 SC[3].Med:=    $07;
 SC[3].Lo:=     $08;
 SC[3].Back:=   $07;
 SC[3].Shadow:= $00;
 SC[3].State:=  BoxInOut+BoxShadow;
 SC[4].Hi:=     $0D;
 SC[4].Med:=    $00;
 SC[4].Lo:=     $00;
 SC[4].Back:=   $05;
 SC[4].State:=  BoxOut;
 SC[5].Hi:=     $0F;
 SC[5].Med:=    $07;
 SC[5].Lo:=     $08;
 SC[5].Back:=   $07;
 SC[5].Shadow:= $00;
 SC[5].State:=  BoxOut;
 SC[6].Hi:=     $0F;
 SC[6].Med:=    $08;
 SC[6].Lo:=     $08;
 SC[6].Back:=   $00;
 SC[6].Shadow:= $00;
 SC[6].State:=  BoxOut;
 SC[7].Hi:=     $0F;
 SC[7].Med:=    $08;
 SC[7].Lo:=     $08;
 SC[7].Back:=   $07;
 SC[7].Shadow:= $00;
 SC[7].State:=  BoxIn;
 For I:=0 To $FF Do
  Begin
   BD[I].Hi:=   $0F;
   BD[I].Med:=  $08;
   BD[I].Lo:=   $00;
   BD[I].Back:= I;
   BD[I].State:=BoxOut;
  End;
 ColS[$100]:=0;
 ClearScreen(8);
 Box(0,0,MaxX-1,17,SC[0]);
 Box(4,20,MaxX-4,54,SC[1]);
 Box(MaxX-60,27,MaxX-14,45,SC[2]);
 Box(4,58,MaxX-4,MaxY-22,SC[3]);
 Box(0,MaxY-18, Maxx,MaxY,SC[4]);
 Box(12,MaxY-90, 39,MaxY-72,SC[5]);
 Box(44,MaxY-90,424,MaxY-72,SC[5]);
 Box(12,MaxY-70, 39,MaxY-52,SC[5]);
 Box(44,MaxY-70,424,MaxY-52,SC[5]);
 Box(12,MaxY-50, 39,MaxY-32,SC[5]);
 Box(44,MaxY-50,424,MaxY-32,SC[5]);
 FontStyle.BColor:=SC[0].Back;
 FontStyle.Color:=$f;
 FontStyle.UseHanja:=True;
 FontStyle.Width:=2;
 RhanFont(0,'ad24.fnt');
 REngFont(0,'ad24.Eng');
 PutText(MaxX Shr 1 -160,1,'Palette Editor V0.1');
 FontStyle.BColor:=SC[4].Back;
 FontStyle.Width:=1;
 PutText(MaxX-55,MaxY-16,'we');
 PutText(5,MaxY-17,Fname);
 FontStyle.BColor:=SC[1].Back;
 PutText(20,28,' e  a Ae w a?? ');
 For I:=0 To ViewMaxY Do
  Begin
   Box(12,68+I*24,39,86+I*24,SC[5]);
   Box(509,67+I*24,548,87+I*24,SC[6]);
  End;
 Case Mode Of
  6:Begin
     Box(554,67,580,582,SC[7]);
     For I:=69 To 580  DO
      Hline(556,577,I,(I-69) Shr 1);
    End;
  Else
   Box(554,67,580,326,SC[7]);
   For I:=69 To 324 DO
    Hline(556,577,I,I-69);
  End;
End;

Procedure InitVar;
Var
 I:Byte;
Begin
 ColN:=0;Ey:=0;Ex:=0;Fy:=0;SelC[0]:=0;SelC[1]:=0;
 For I:=0 To $FF Do
  If I<16 Then ColS[I]:=16 Else Cols[I]:=0;
 ColS[$100]:=0;
End;

Procedure ViewColS;
Var
 I,J,K,C:Byte;
 S:String;
 L,M:Word;
Begin
 SelectCol;
 K:=0; I:=0;
 If FY>0 Then K:=AD[Fy];
 Repeat
  L:=I*24;C:=ColS[Fy+I];
  Str(C:2,S);
  FontStyle.BColor:=SC[3].Back;
  PutText(20,70+L,S);
  For M:=0 To 37 Do
   If (M Shr 1<C) And (K+M Shr 1<256) Then
     Vline(68+L,86+L,M+510,K+M Shr 1)
    Else
     Vline(68+L,86+L,M+510,0);
  If C<19 Then
   For M:=67+L To 87+L Do
    Hline(44+C*24,500,M,7);
  For J:=0 To C-1 Do
   Box(44+J*24,67+L,64+J*24,87+L,BD[K+J]);
  Inc(K,C);Inc(I);
 Until(AD[Fy+I]>255) Or (I>ViewMaxY);
End;

Procedure Add;
Var
 I,J:Word;
Begin
 J:=0;
 For I:=0 To 256 Do
  Begin
   AD[I]:=J;
   Inc(J,ColS[I]);
  End;
End;

Procedure WClock;
Begin
 FontStyle.BColor:=SC[2].Back;
 If T1<>ReadCmos(4) Then
  Begin
   T1:=ReadCmos(4);
   Str(UnBCD(ReadCmos(4)),S1);S1:='0'+S1;
   Delete(S1,1,Ord(S1[0])-2);
   PutText(MaxX-57,29,S1);
  End;
 If T2<>ReadCmos(2) Then
  Begin
   T2:=ReadCmos(2);
   Str(UnBCD(ReadCmos(2)),S2);S2:='0'+S2;
   Delete(S2,1,Ord(S2[0])-2);
   PutText(MaxX-33,29,S2);
  End;
 If T3<>ReadCmos(0) Then
  Begin
   T3:=ReadCmos(0);
   If T3 And 1 =1 Then
     PutText(MaxX-41,29,' ')
    Else
     PutText(MaxX-41,29,':');
  End;
End;

Procedure WriteRgb;
Type
 Po=Record
     y,c:Byte;
    End;
Const
 RgbPo:Array[0..2] Of Po = ((y:89;c:12),(y:69;c:10),(Y:49;c:9));
Var
 S:String;
 I:Word;
 J,k:Byte;
Begin
 For J:=0 To 2 Do
  Begin
   K:=Palette[Coln*3+j];
   If _LRGB[J]<>K Then
    Begin
     Str(K:2,S);
     FontStyle.BColor:=7;
     PutText(20,MaxY-RgbPo[j].Y,S);
     _LRGB[j]:=K;
     For I:=MaxY-RgbPo[j].Y To MaxY-RgbPo[j].Y+16 DO
      Begin
       If K>0 Then HLine(45,45+K*6,i,RgbPo[j].C);
       If K<63 Then HLine(45+K*6,423,i,7);
      End;
    End;
  End;
End;

Procedure Grad;
Begin
 If SelC[0]=SelC[1] Then Exit;
 FindSel(J,K);
 Grade(J,K,Palette);
 Srgb(Palette);
End;

Procedure MovPa;
Var
 P:PaletteType;
 I,J:Word;
Begin
 FindSel(I,J);
 Move(Palette[I*3],P[0],(J-I+1)*3);
 Move(P[0],Palette[ColN*3],(J-I+1)*3);
 SRGB(Palette);
 WriteRGB;
End;

Procedure Pudi;
Begin
 DiBox.Hi:=     $09;
 DiBox.Med:=    $01;
 DiBox.Lo:=     $08;
 DiBox.Back:=   $01;
 DiBox.Shadow:= $00;
 DiBox.THi:=    $0C;
 DiBox.TMed:=   $00;
 DiBox.TLo:=    $00;
 DiBox.TBack:=  $04;
 DiBox.State:=  BoxOut;
 DiBox.State:=  DiBox.State Or BoxShadow;
 DiBox.Title:=  $0F;
 DiBox.TWidth:= $01;
 DiBox.TPos:=   DiLeft;
End;

Procedure ReFresh;
Begin
 T1:=24; T2:=60; T3:=60;
 Init; Add; ReSr:=False;
 ViewCols; WriteRGB;
End;

Procedure NewPe;
Begin
 Setmode(Mode);
 ReSr:=True;
 InitVar;
 ReFresh;
End;

Procedure GoHome;
Begin
 UnColN;
 Ex:=0; Ey:=0; Fy:=0; ColN:=0;
 SelectCol; ViewColS; WriteRGB;
End;

Procedure GoEnd;
Begin
 UnColN;
 FindEnd(Ey,Fy);
 ColN:=$FF; Ex:=Cols[Ey+Fy]-1;
 SelectCol;
 ViewCols; WriteRGB;
End;

Procedure Go_;
Begin
 UnColN;
 If Not ReDr Then Box(44+C1*24,67+C2*24,64+C1*24,87+C2*24,BD[Coln]);
 If Ex>Cols[Fy+Ey]-1 Then Ex:=Cols[Fy+Ey]-1;
 ColN:=AD[Fy+Ey]+Ex;
 If ((Ka2=#72) And (C3<>FY) And (C2=0)) Or
    ((Ka2=#80) And (C3<>FY) And (C2=ViewMaxY)) Or ReDr Then ViewCols
  Else
   Begin
    BD[ColN].State:=BoxInOut;
    Box(44+Ex*24,67+Ey*24,64+Ex*24,87+Ey*24,BD[Coln]);
    End;
   WriteRGB;
End;

Procedure GoUp;
Begin
 If EY>0 Then Dec(Ey)
  Else
   If Fy>0 Then Begin Dec(Fy); ReDr:=True; End;
 Go_;
End;

Procedure GoDown;
Begin
 If AD[Fy+EY+1]<256 Then
  If Ey<ViewMaxY Then Inc(Ey)
   Else If Ey=ViewMaxY Then Begin Inc(Fy); ReDr:=True; End;
 Go_;
End;

Procedure GoLeft;
Begin
 If Ex>0 Then Begin Dec(Ex); Go_; End
  Else
   If Ey+Fy>0 Then Begin Ex:=20; GoUp; End;
End;

Procedure GoRight;
Begin
 If Ex<ColS[Fy+Ey]-1 Then Begin Inc(Ex); Go_; End
  Else If (AD[Fy+EY+1]<256) Then Begin Ex:=0; GoDown; End;
End;

Procedure DeRgb(J:byte);
Begin
 If Palette[ColN*3+J]=0 Then Exit;
 Dec(Palette[Coln*3+J]);
 Psrgb(ColN,Palette[Coln*3],Palette[Coln*3+1],Palette[Coln*3+2]);
 WriteRGB;
End;

Procedure InRgb(J:Byte);
Begin
 If Palette[ColN*3+J]=63 Then Exit;
 Inc(Palette[Coln*3+J]);
 Psrgb(ColN,Palette[Coln*3],Palette[Coln*3+1],Palette[Coln*3+2]);
 WriteRGB;
End;

Procedure SelectC(I:Byte);
Begin
 UnSelectCol;
 SelC[I]:=ColN;
 ViewCols;
End;

Procedure Help;
Begin
End;

Procedure Save;
Begin
 DrawDi(MaxX Shr 1 -240,MaxY Shr 1 -64,MaxX Shr 1 +200,MaxY Shr 1 -20,'- Save -           wi ba',DiBox);
 Readkey;
 WritePePal(Fname);
 ReFresh;
End;

Procedure Load;
Begin
 DrawDi(MaxX Shr 1 -240,MaxY Shr 1 -64,MaxX Shr 1 +200,MaxY Shr 1 -20,'- Load -           wi ba',DiBox);
 Gotoxy(13,13);
 readln(fname);
 InitVar;
 ReadPePal(Fname);Srgb(Palette);
 ReFresh;
End;

Procedure Fi1;
Var
 i:Byte;
Begin
 Grgb(Palette);
 For i:=0 TO 255 Do PSRGB(i,0,0,0);
End;

Procedure Fi;
Var
 p:FadeIO;
Begin
 Move(Palette,P.Pal,768);
 P.Cycle:=64;
 P.SNum:=0;
 P.ENum:=255;
 P.KeyPres:=True;
 Fade(P);
End;

Procedure Fo;
Var
 P:FadeIO;
Begin
 P.R:=0;
 P.G:=0;
 P.B:=0;
 P.Cycle:=64;
 P.SNum:=0;
 P.ENum:=255;
 P.KeyPres:=True;
 FadeToPal(P);
End;

Begin
 Haninit;
 Fname:=Fexpand('Untitled.Pal');
 Mode:=4;DirectVideo:=False;
 ReSr:=True; InitVar; Pudi;
 Setmode(Mode);Fi1;
 PeExit:=False; T1:=24; T2:=60; T3:=60;
 Case Mode Of
   3:ViewMaxY:=09;
   4:ViewMaxY:=12;
   5:ViewMaxY:=17;
   6:ViewMaxY:=24;
  Else Halt(0); End;
 Init;
 If ParamCount>0 Then
   Begin
    Fname:=FexPand(ParamStr(1));
    ReadPePal(Fname);
    ReSr:=False;
   End;
 Add;ViewCols;WriteRGB;
 Fi;
 Repeat
  Repeat
   WCLock;
  Until(keypressed);
  Ka1:=UpCase(ReadKey);
  If Ka1='Q' Then DeRgb(0);
  If Ka1='W' Then InRgb(0);
  If Ka1='A' Then DeRgb(1);
  If Ka1='S' Then InRgb(1);
  If Ka1='Z' Then DeRgb(2);
  If Ka1='X' Then InRgb(2);
  If (Ka1='+') And (Cols[Fy+Ey]<19) And (Cols[Fy+Ey+1]>0) Then
   Begin
    Inc(Cols[Fy+Ey]);
    Dec(Cols[Fy+Ey+1]);
    If Cols[Fy+Ey+1]=0 Then
     Begin
      DelCols(Fy+Ey+1);
      FindEndCols(I);
      Dec(I,Fy);
      If I<=ViewMaxY Then
       Begin
        Inc(i);
        Box(12,68+I*24,39,86+I*24,SC[5]);
        Box(509,67+I*24,548,87+I*24,SC[6]);
        For J:=67+I*24 To 87+I*24 Do
         Hline(44,500,J,7);
       End;
     End;
    Add;
    ViewColS;
   End;
  If (Ka1='-') And ((ColN<255) Or (ColN=255) And (Ex>0))  Then
   Begin
    Dec(Cols[Fy+Ey]);
    If _417 And 3>0 Then InsCols(Fy+Ey+1);
    Inc(Cols[Fy+Ey+1]);
    If Cols[Fy+Ey]=0 Then
     Begin
      DelCols(Fy+Ey);
      FindEndCols(I);
      Dec(I,Fy);
      If I<=ViewMaxY Then
       Begin
        Inc(i);
        Box(12,68+I*24,39,86+I*24,SC[5]);
        Box(509,67+I*24,548,87+I*24,SC[6]);
        For J:=67+I*24 To 87+I*24 Do
         Hline(44,500,J,7);
       End;
     End;
    IF Cols[Fy+Ey]>19 Then
     Begin
      Cols[Fy+Ey+1]:=Cols[Fy+Ey+1]+Cols[Fy+Ey]-19;
      Cols[Fy+Ey]:=19;
     End;
    If Cols[Fy+Ey+1]>19 Then
     Begin
      I:=1;
      Repeat
       Cols[Fy+Ey+I+1]:=Cols[Fy+Ey+I+1]+Cols[Fy+Ey+I]-19;
       Cols[FY+Ey+I]:=19;
       Inc(I);
      Until Cols[Fy+Ey+I]<20
     End;
    Add;
    If Ex=ColS[Fy+Ey] Then
     Begin
      Ex:=0;Inc(Ey);
      If Ey>ViewMaxY Then
       Begin
        Dec(Ey);Inc(Fy);
       End;
     End;
    ViewColS;
   End;
  If Ka1=#0 Then
   Begin
    Ka2:=ReadKey;
    ReDr:=False;
    C1:=Ex; C2:=Ey; C3:=Fy;
    If Ka2=#59 Then Help;
    If Ka2=#60 Then Save;
    If Ka2=#61 Then Load;
    If Ka2=#62 Then NewPe;
    If Ka2=#87 Then ReFresh;
    If (Ka2=#63) Or (Ka2=#64) Then SelectC(Ord(Ka2)-63);
    If Ka2=#65 Then Grad;
    If Ka2=#66 Then MovPa;
    If Ka2=#45 Then PeExit:=True;
    If Ka2=#71 Then GoHome;
    If Ka2=#79 Then GoEnd;
    If Ka2=#72 Then GoUp;
    If Ka2=#80 Then GoDown;
    If Ka2=#75 Then GoLeft;
    If Ka2=#77 Then GoRight;
   End;
 Until PeExit;
 HanDone;
 Fo;
 Setmode(_TextMode);
End.