Unit Svga2;

Interface

Uses Crt,VESADRV;

{$R-}
Type
 PaletteType=Array[0..767] of Byte;
 RGBType=Array[0..255] of Record
                           R,G,B:Byte;
                          End;
 ConvType=Array[0..255] of Byte;
 BoxType=Record
          Hi,Med,Lo,Shadow,Back:Byte;
          State:Byte;
         End;
 PcxHdr=Record
         id:Byte;
         Version:Byte;
         Encoding:Byte;
         BitsPerPixel:Byte;
         x1,y1:Word;
         x2,y2:Word;
         HRes,VRes:Word;
         Palette16:Array[0..47] of Byte;
         VideoMode:Byte;
         NPlanes:Byte;
         BytesPerLine:Word;
         Reserved:Byte;
         PaletteInfo:Byte;
        End;
 FadeIO=Record
         Pal:PaletteType;
         R,G,B:Byte;
         SNum,ENum:Byte;
         Cycle:Byte;
         KeyPres:Boolean;
        End;

 FontStyleType=Record
                OnlyEng,UseHanJa:Boolean;
                Width,Height:Byte;
                Color,Bcolor:Byte;
                LineColor:Byte;
                HanFont,EngFont:Byte;
                State:Byte;
               End;

 RAType=Record
         UpDate_In_Progress:Boolean;
         Divider:Byte;
         Rate_Select:Byte;
        End;
 RBType=Record
         SetRTCTimer,
         Peridodic_Interrupt_Enable,
         Alarm_Interrupt_Enable,
         Update_Interrupt_Enable,
         SQuare_Wave_Enable,
         Binary_Enable,
         Hour_24_Enable,
         Summer_Time_Enable:Boolean;
        End;
 RCTyep=Record
         Alarm_Interrupt_Flag,
         Periodic_Interrupt_Flag,
         UpDate_Interrupt_Flag:Boolean;
        End;
 SCheckType=Record
             CmosPower,
             CheckSum,
             System,
             Ram,
             C_Drive,
             RTCTime:Boolean;
            End;
 SystemType=Record
             DiskDrive,VideoCard:Byte;
             CoProcess,Drive:Boolean;
             FDD1,FDD2:Byte;
             HDD1,HDD2:Byte;
             BaseRam:Word;
             Expanded:Word;
            end;


Const
 VideoMem       :Word = $A000;
 _TextMode      :Byte =   $00;
 _320x200Mode   :Byte =   $01;
 _640x350Mode   :Byte =   $02;
 _640x400Mode   :Byte =   $03;
 _640x480Mode   :Byte =   $04;
 _800x600Mode   :Byte =   $05;
 _1024x768Mode  :Byte =   $06;
 _1280x1024Mode :Byte =   $07;
 VideoSeg       :Word = $A000;
 BoxNormal      :Byte =   $00;
 BoxShadow      :Byte =   $01;
 BoxThick       :Byte =   $02;
 BoxIn          :Byte =   $10;
 BoxOut         :Byte =   $20;
 BoxInOut       :Byte =   $30;
 LineStyleType:Array[1..5,0..7] of Byte =
   ((1,1,1,1,1,1,1,1),
    (1,0,1,0,1,0,1,0),
    (1,1,0,0,1,1,0,0),
    (1,0,0,0,1,0,0,0),
    (1,1,1,0,1,1,1,0));

 NonError    :Word  =$00;
 FileNotFound:Word  =$01;
 SizeNotMatch:Word  =$02;
 Normal      :Byte  =$00;
 Um          :Byte  =$01;
 Bold        :Byte  =$02;
 OutLine     :Byte  =$04;
 UnderLine   :Byte  =$08;
 UpLine      :Byte  =$10;

 Dates:Array[1..7] of String[3]=('Sun','Mon','Tue','Wed','Thu','Fri','Sta');
 VideoCardType :Array[0..3] of String[7] = ('EGA_VGA','CGA4','CGA8','MONO');
 FddType :Array[0..4] of String[6] =
   (' NONE',' 360KB',' 1.2MB',' 720KB','1.44MB');


Var
 GMode:Boolean;
 MaxX,MaxY:Word;
 MaxBank,GraphicMode:Byte;
 LineStyle:Byte;
 Palette:paletteType;
 NulColor:Word;
 SetConvertPalette:Boolean;
 BoxColor:Array[0..13] of BoxType;
 SetRGBPalette,SetGrayPalette:Boolean;
 ConvertPalette:Boolean;
 PcxReadError:Boolean;
 ConvertP:ConvType;

 FontStyle:FontStyleType;
 ReadFontError:Word;

 BiosClockCounter:Longint Absolute $0000:$046C;
 Com:Array[1..4] of word absolute $0000:$0400;
 Lpt:Array[1..4] of word absolute $0000:$0408;


Procedure SetMode(Mode:Byte);
Procedure FindPosition(X,Y:Integer;Var Bank:Byte;Var Addr:Word);
Function  GetPixel(X,Y:Integer):Byte;
Procedure PutPixel(X,Y:Integer; Color:Byte);
Procedure LinePut(X,Y:Integer; Var P; N:Word);
Procedure LineGet(X,Y:Integer; Var P; N:Word);
Function  ImageSize(X1,Y1,X2,Y2:Word):Word;
Procedure GetImage(X1,Y1,X2,Y2:Integer;Var Get);
Procedure PutImage(X,Y:Integer;Var Put);
Procedure HLine(X1,X2,Y:Integer; Color:Byte);
Procedure VLine(Y1,Y2,X:Integer; Color:Byte);
Procedure Line(X1,Y1,X2,Y2:Integer; Color:Byte);
Procedure ClearScreen(Color:Byte);
Procedure Circle(X,Y,R:Integer; Color:Byte);
Procedure Circlef(X,Y,R:Integer; Color:Byte);
Procedure Ellipse(X,Y,RX,RY:Integer; Color:Byte);
Procedure Ellipsef(X,Y,RX,RY:Integer; Color:Byte);
Procedure Bezier3(X0,Y0,X1,Y1,X2,Y2:Integer; Color:Byte);
Procedure Bezier4(X0,Y0,X1,Y1,X2,Y2,X3,Y3:Integer; Color:Byte);
Procedure Box(X1,Y1,X2,Y2:Integer; BoxCol:BoxType);
Procedure BoxFIll(X1,Y1,X2,Y2:Integer; Color:Byte);
Procedure SRGB(Var P);
Procedure GRGB(Var P);
Procedure PSRGB(ColorNum,Red,Green,Blue:Byte);
Procedure PGRGB(ColorNum:Byte; Var Red,Green,Blue:Byte);
Procedure BSRGB(ColorNum:Byte; Var Pal; CLen:Byte);
Procedure BGRGB(ColorNum:Byte; Var Pal; CLen:Byte);
Procedure WRGB(FileName:String; P:PaletteType);
Procedure RRGB(FileName:String; Var P:PaletteType);
Procedure Gray(Var P1,P2:PaletteType);
Procedure Grade(Sc,Ec:Byte; Var P:PaletteType);
Procedure Fade(P:FadeIO);
Procedure FadeToPal(P:FadeIO);
Procedure ConvPalette(Var Pp1,Pp2:PaletteType; Var Conv:ConvType);
Procedure PcxSlow(FileName:String; X,Y,X1,Y1,X2,Y2:Integer; Var P:PaletteType);
Procedure PcxHeader(FileName:String;Var Header:Pcxhdr);
Procedure PcxColor(FileName:String;Var Color:PaletteType);

Procedure Puttext(x,y,Del:Integer; stri:String);
Procedure RHanFont(N:Byte; Name:String);
Procedure REngFont(N:Byte; Name:String);
Procedure RHSpeFont(Name:String);
Procedure RSpeFont(Name:String);
Procedure RHjFont(Name:String);
Procedure HanInit;
Procedure HanDone;

Function _ToHex(A:Word):String;
Function _ByteToBin(B:Byte):String;
Function _BinToByte(B:String):Byte;
Procedure _KeySpeed(KDelay,KRate:byte);
Procedure _CursorSize(StL,EnL:Byte);
Procedure _AutoBye(So,Wai:Word);
Procedure _MSound(Count:Word);
Procedure _BlockShl(Var Block; Size:Word; LeftShift:Byte);
Procedure _BlockShr(Var Block; Size:Word; RightShift:Byte);
Procedure _BlockDec(Var Block; Size:Word; Decrement:Byte);
Procedure _BlockInc(Var Block; Size:Word; Increment:Byte);
Procedure _FillByte(var Block; Count:Word; OutPutData:Byte);
Procedure _FillBytep(S,O:Word; Count:Word; OutPutData:Byte);
Procedure _FillWord(var block; Count:Word; Hi,Lo:Byte);
Procedure _FillWordp(S,O:Word; Count:Word; Hi,Lo:Byte);
Procedure _MoveW(Var A,B; N:Word);
Procedure _OrMoveW(Var A,B; N:Word);
Procedure _GetFont(Code:Byte; Var Table; Count:Byte);
Procedure _SetFont(Code:Byte; Var Table; Count:Byte);

Function ReadCmos(Addr:Byte):Byte;
Procedure WriteCmos(Addr,Data:Byte);
Function UnBCD(S:Byte):Byte;
Procedure SetTime(Hour,Min,Sec:Byte);
Procedure SetAlramTime(Hour,Min,Sec:Byte);
Procedure SetDateTime(Year,Month,Day:Byte);
Procedure GetTime(Var Hour,Min,Sec,Date:Byte);
Procedure GetAlramTime(Var Hour,Min,Sec:Byte);
Procedure GetDateTime(Var Year,Month,Day:Byte);
Procedure GetSRegsterA(R:RAType);
Procedure GetSRegsterB(R:RBType);
Procedure GetSRegsterC(R:RCTyep);
Procedure SCheck(R:SCheckType);
Procedure CheckSystem(R:SystemType);

Implementation

Type
 FontType=Array[0..31] Of Byte;
 FType=Array[0..1,0..7,0..19] Of FontType;
 SType=Array[0..1,0..3,0..21] Of FontType;
 TType=Array[0..1,0..3,0..27] Of FontType;
 EType=Array[0..1,0..255,0..15] Of Byte;
 HSType=Array[0..127] Of FontType;
 SpeType=Array[0..1181] Of FontType;
 HanJaType=Array[0..511] Of Record
                             Code:Word;
                             HD:FontType;
                            End;

Var
 HanFontF:Pointer;
 HanFontS:Pointer;
 HanFontT:Pointer;
 EngFont:Pointer;
 HanJa:Pointer;
 HanSpeFont:Pointer;
 SpeFont:Pointer;
 HanJaFont:String;
 HanJaCodes:Word;
 HjHeader:Byte;
 HanJaFontF,HSFontF,SpecialFontF:Boolean;


Procedure SetMode(Mode:Byte);
Begin
 SetGraphicMode(Mode);
 Gmode:=_GMode;
 MaxX:=_MaxX;
 MaxY:=_MaxY;
 MaxBank:=_MaxBank;
 GraphicMode:=_GraphicMode;
End;

Procedure FindPosition(X,Y:Integer;Var Bank:Byte;Var Addr:Word); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov AX,Y
 Mul MaxX
 Add AX,X
 Adc DX,0
 Les DI,Addr
 Mov ES:[DI],AX
 Les DI,Bank
 Mov ES:[DI],DL
@Q:
End;

Procedure PutPixel(X,Y:Integer; Color:Byte); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov AX,X
 Cmp AX,0
 Jl  @Q
 Cmp AX,MaxX
 Jge @Q
 Mov AX,Y
 Cmp AX,0
 Jl  @Q
 Cmp AX,MaxY
 Jge @Q
 Mul MaxX
 Add AX,X
 Adc DX,0
 Mov ES,VideoSeg
 Mov DI,AX
 Mov BL,DL
 Call SetWBank
 Mov AL,Color
 Mov ES:[DI],AL
@Q:
End;

Function GetPixel(X,Y:Integer):Byte; Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov AX,X
 Cmp AX,0
 Jl  @Q
 Cmp AX,MaxX
 Jge @Q
 Mov AX,Y
 Cmp AX,0
 Jl  @Q
 Cmp AX,MaxX
 Jge @Q
 Mul MaxX
 Add AX,X
 Adc DX,0
 Mov ES,VideoSeg
 Mov DI,AX
 Mov BL,DL
 Call SetRBank
 Mov AL,ES:[DI]
 Xor AH,AH
@Q:
End;

Procedure LinePut(X,Y:Integer; Var P; N:Word); Assembler;
Var
 SkipByte:Word;
Asm
 Push DS
 Push SI
 Push ES
 Push DI
 Cmp Gmode,False;
 Je @Q
 Mov AX,X
 Cmp AX,MaxX
 Jge @Q
@l0:
 Xor BX,BX
 Mov skipByte,BX
 Cmp AX,0
 Jge @l1
 Mov X,BX
 Sub BX,AX
 Mov skipByte,BX
@l1:
 Add AX,N
 Cmp AX,MaxX
 Jl  @l2
 Mov AX,MaxX
 Sub AX,X
 Mov N,AX
@l2:
 Mov AX,Y
 Mul MaxX
 Add AX,X
 Adc DX,0
 Mov ES,VideoSeg
 Mov DI,AX
 Mov BL,DL
 Call SetWBank
 Lds SI,P
 Add SI,SkipByte
 Mov AX,DI
 Add AX,N
 Jc  @1
 Mov CX,N
 Rep Movsb
 Jmp @Q
@1:
 Mov AX,$FFFF
 Sub AX,DI
 Sub N,AX
 Mov CX,AX
 Inc CX
 Rep Movsb
 Inc BL
 Call SetWBank
 Mov CX,N
 Rep Movsb
@Q:
 Pop DI
 Pop ES
 Pop SI
 Pop DS
End;

Procedure LineGet(X,Y:Integer; Var P; N:Word); Assembler;
Var
 SkipByte:Word;
Asm
 Push DS
 Push SI
 Push ES
 Push DI
 Cmp Gmode,False;
 Je @Q
 Mov AX,X
 Cmp AX,MaxX
 Jge @Q
@l0:
 Xor BX,BX
 Mov skipByte,BX
 Cmp AX,0
 Jge @l1
 Mov X,BX
 Sub BX,AX
 Mov skipByte,BX
@l1:
 Add AX,N
 Cmp AX,MaxX
 Jl  @l2
 Mov AX,MaxX
 Sub AX,X
 Mov N,AX
@l2:
 Mov AX,Y
 Mul MaxX
 Add AX,X
 Adc DX,0
 Mov DS,VideoSeg
 Mov SI,AX
 Mov BL,DL
 Call SetRBank
 Les DI,P
 Add SI,SkipByte
 Mov AX,SI
 Add AX,N
 Jc  @1
 Mov CX,N
 Rep Movsb
 Jmp @Q
@1:
 Mov AX,$FFFF
 Sub AX,SI
 Inc AX
 Sub N,AX
 Mov CX,AX
 Rep Movsb
 Inc BL
 Call SetRBank
 Mov CX,N
 Rep Movsb
@Q:
 Pop DI
 Pop ES
 Pop SI
 Pop DS
End;

Function ImageSize(X1,Y1,X2,Y2:Word):Word; Assembler;
Asm
 Mov AX,Y2
 Sub Ax,Y1
 Inc AX
 Mov DX,X2
 Sub DX,X1
 Inc DX
 Mul DX
 Add AX,4
End;

Procedure GetImage(X1,Y1,X2,Y2:Integer;Var Get); Assembler;
Var
 N,N2:Word;
Asm
 Push DS
 Cmp Gmode,False;
 Je @Q
 Mov AX,Y1
 Cmp AX,MaxY
 Jge @Q
 Cmp AX,0
 Jge @CmY2
 Xor AX,AX
 Mov Y2,AX
@CmY2:
 Mov AX,Y2
 Cmp AX,MaxY
 Jl  @CmX1
 Mov AX,MaxY
 Dec AX
 Mov Y2,AX
@CmX1:
 Mov AX,X1
 Cmp AX,MaxX
 Jge @Q
 Cmp AX,0
 Jge @CmX2
 Xor AX,AX
 Mov X1,AX
@CmX2:
 Mov AX,X2
 Cmp AX,MaxX
 Jl  @Get
 Mov AX,MaxX
 Sub AX,X1
 Mov X2,AX
@Get:
 Les DI,Get
 Mov AX,X2
 Sub AX,X1
 Inc AX
 Mov N,AX
 Mov N2,AX
 Stosw
 Mov AX,Y2
 Sub AX,Y1
 Inc AX
 Stosw
 Mov DS,VideoSeg
 Mov AX,Y1
 Mul MaxX
 Add AX,X1
 Adc DX,0
 Mov SI,AX
 Mov BL,DL
 Call SetRBank
@Y:
 Mov AX,SI
 Add AX,N
 Jc  @GY2
 Mov CX,N
 Rep Movsb
 Jmp @Next
@GY2:
 Mov AX,$FFFF
 Sub AX,SI
 Inc AX
 Sub N,AX
 Rep Movsb
 Inc BL
 Call SetRBank
 Mov CX,N
 Rep Movsb
@Next:
 Inc Y1
 Mov AX,Y1
 Cmp AX,Y2
 Jg @Q
 Sub SI,N2
 Mov AX,MaxX
 Add SI,AX
 Jnc @Y
 Inc BL
 Call SetRBank
 Jmp @Y
@Q:
 Pop DS
End;

Procedure PutImage(X,Y:Integer;Var Put); Assembler;
Var
 Xs,Ys,SkipX,SkipY,N,N2:Integer;
Asm
 Push DS
 Cmp Gmode,False;
 Je @Q
 Xor AX,AX
 Mov SkipX,AX
 Mov SkipY,AX
 Mov AX,X
 Cmp AX,MaxX
 Jge @Q
 Cmp AX,0
 Jge @CmY
 Xor AX,$FFFF
 Inc AX
 Mov SkipX,AX
 Xor AX,AX
 Mov X,AX
@CmY:
 Mov AX,Y
 Cmp AX,MaxY
 Jge @Q
 Cmp AX,0
 Jge @Put
 Xor AX,$FFFF
 Inc AX
 Mov SkipY,AX
 Xor AX,AX
 Mov Y,AX
@Put:
 Lds SI,Put
 Lodsw
 Mov Xs,AX
 Lodsw
 Mov Ys,AX
 Mul SkipY
 Add SI,AX
 Mov AX,Y
 Mul MaxX
 ADD AX,X
 Adc DX,0
 Mov ES,VideoSeg
 Mov DI,AX
 Mov Bl,DL
 Call SetWBank
 Mov AX,Xs
 Sub AX,SkipX
 Mov Xs,AX
 Mov N2,AX
 Add AX,X
 Cmp AX,MaxX
 Jl @Y
 Mov AX,MaxX
 Sub AX,X
 Mov N2,AX
 Cmp SkipY,0
 Je @Y
 Mov AX,Ys
 Sub AX,SkipY
 Mov YS,AX
@Y:
 Mov AX,N2
 Mov N,AX
 Add SI,SkipX
 Mov AX,DI
 Add AX,N
 Jc  @PY2
 Mov CX,N
 Rep Movsb
 Jmp @Next
@PY2:
 Mov AX,$FFFF
 Sub AX,DI
 Inc AX
 Sub N,AX
 Rep Movsb
 Inc BL
 Call SetWBank
 Mov CX,N
 Rep Movsb
@Next:
 Inc Y
 Mov AX,Y
 Cmp AX,MaxY
 Jge @Q
 Dec Ys
 Cmp Ys,1
 Jl  @Q
 Mov AX,MaxX
 Mov CX,DI
 Sub CX,N2
 Add CX,AX
 Mov DI,CX
 Jnc @Y1
 Inc BL
 Call SetWbank
 Jmp @Y1
@Y1:
 Mov AX,Xs
 Cmp AX,N2
 Jle @Y
 Sub AX,N2
 Mov CX,AX
 Rep Lodsb
 Jmp @Y
@Q:
 Pop DS
End;

Procedure HLine(X1,X2,Y:Integer; Color:Byte); Assembler;
Var N:Word;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov AX,Y
 Jl  @Q
 Cmp AX,MaxY
 Jge @Q
 Mov AX,X1
 Cmp AX,X2
 Jl  @0
 Je  @3
 Mov BX,X2
 Mov X1,BX
 Mov X2,AX
@0:
 Mov AX,X1
 Cmp AX,0
 Jge @01
 Xor AX,AX
 Mov X1,AX
@01:
 Mov BX,X2
 Cmp BX,MaxX
 Jl  @02
 Mov BX,MaxX
 Dec BX
 Mov X2,BX
@02:
 Mov AX,X2
 Sub AX,X1
 Mov BX,AX
 Mov AX,Y
 Mul MaxX
 Add AX,X1
 Adc DX,0
 Mov ES,VideoSeg
 Mov DI,AX
 Mov BL,DL
 Call SetWbank
 Mov AX,X2
 Sub AX,X1
 Mov N,AX
 Mov AX,DI
 Add AX,N
 Jc  @1
 Mov CX,N
 Inc CX
 Mov AL,Color
 Rep Stosb
 Jmp @Q
@1:
 Mov AX,$FFFF
 Sub AX,DI
 Inc AX
 Sub N,AX
 Mov CX,AX
 Mov AL,Color
 Rep Stosb
 Inc BL
 Call SetWBank
 Mov CX,N
 Mov AL,Color
 Rep Stosb
 Jmp @Q
@3:
 Mov AX,X1
 Push AX
 Mov AX,Y
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
@Q:
End;

Procedure VLine(Y1,Y2,X:Integer; Color:Byte); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov AX,X
 Jl  @Q
 Cmp AX,MaxX
 Jge @Q
 Mov AX,Y1
 Cmp AX,Y2
 Jl  @0
 Je  @3
 Mov BX,Y2
 Mov Y1,BX
 Mov Y2,AX
@0:
 Mov AX,Y1
 Cmp AX,0
 Jge @01
 Xor AX,AX
 Mov Y1,AX
@01:
 Mov BX,Y2
 Cmp BX,MaxY
 Jl  @02
 Mov BX,MaxY
 Dec BX
 Mov Y2,BX
@02:
 Mov AX,Y2
 Sub AX,Y1
 Inc AX
 Mov CX,AX
 Mov AX,Y1
 Mul MaxX
 Add AX,X
 Adc DX,0
 Mov ES,VideoSeg
 Mov DI,AX
 Mov BL,DL
 Mov AH,Color
@1:
 Call SetWBank
@2:
 Mov ES:[DI],AH
 Dec CX
 Je  @Q
 Add DI,MaxX
 Jnc @2
 Inc BL
 Jmp @1
@3:
 Mov AX,X
 Push AX
 Mov AX,Y1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
@Q:
End;

Procedure Line(X1,Y1,X2,Y2:Integer; Color:Byte);
Var
 DX,dy,s,step:Integer;
 ls:Word;
 P:Pointer;
Begin
 If Not Gmode Then Exit;
 If (X1=X2) And (Y1=Y2) Then
  Begin
   PutPixel(X1,Y1,Color);
   Exit;
  End;
 GetMem(P,8);
 Move(LineStyleType[LineStyle],P^,8);
 If Y1=Y2 Then
  Asm
   Mov AX,X1
   And AX,7
   Mov ls,AX
   Mov AX,Y1
   Jl  @Q
   Cmp AX,MaxY
   Jge @Q
   Mov AX,X1
   Cmp AX,X2
   Jl  @0
   Mov BX,X2
   Mov X1,BX
   Mov X2,AX
@0:
   Mov AX,X1
   Cmp AX,0
   Jge @01
   Xor AX,AX
   Mov X1,AX
@01:
   Mov BX,X2
   Cmp BX,MaxX
   Jl  @02
   Mov BX,MaxX
   Dec BX
   Mov X2,BX
@02:
   Mov AX,X2
   Sub AX,X1
   Inc AX
   Mov CX,AX
   Mov AX,Y1
   Mul MaxX
   Add AX,X1
   Adc DX,0
   Mov ES,VideoSeg
   Mov DI,AX
   Mov BL,DL
   Mov AH,Color
@1:
   Call SetWBank
@2:
   Push ES
   Push DI
   Push AX
   Les DI,P
   Add DI,ls
   Mov AL,ES:[DI]
   Cmp AL,0
   Je  @21
   Pop AX
   Pop DI
   Pop ES
   Mov ES:[DI],AH
   Jmp @22
@21:
   Pop AX
   Pop DI
   Pop ES
@22:
   Inc ls
   Cmp ls,8
   Jne @3
   Mov ls,0
@3:
   Dec CX
   Je  @Q
   Inc DI
   Jne @2
   Inc BL
   Jmp @1
@Q:
  End;
 If X1=X2 Then
  Asm
   Mov AX,Y1
   And AX,7
   Mov ls,AX
   Mov AX,X1
   Jl  @Q
   Cmp AX,MaxX
   Jge @Q
   Mov AX,Y1
   Cmp AX,Y2
   Jl  @0
   Mov BX,Y2
   Mov Y1,BX
   Mov Y2,AX
@0:
   Mov AX,Y1
   Cmp AX,0
   Jge @01
   Xor AX,AX
   Mov Y1,AX
@01:
   Mov BX,Y2
   Cmp BX,MaxX
   Jl  @02
   Mov BX,MaxX
   Dec BX
   Mov Y2,BX
@02:
   Mov AX,Y2
   Sub AX,Y1
   Inc AX
   Mov CX,AX
   Mov AX,Y1
   Mul MaxX
   Add AX,X1
   Adc DX,0
   Mov ES,VideoSeg
   Mov DI,AX
   Mov BL,DL
   Mov AH,Color
@1:
   Call SetWBank
@2:
   Push ES
   Push DI
   Push AX
   Les DI,P
   Add DI,ls
   Mov AL,ES:[DI]
   Cmp AL,0
   Je  @21
   Pop AX
   Pop DI
   Pop ES
   Mov ES:[DI],AH
   Jmp @22
@21:
   Pop AX
   Pop DI
   Pop ES
@22:
   Inc ls
   Cmp ls,8
   Jne @3
   Mov ls,0
@3:
   Mov DX,DI
   Dec CX
   Je  @Q
   Add DI,MaxX
   Cmp DX,DI
   Jb  @2
   Inc BL
   Jmp @1
@Q:
  End;
 ls:=X1 And 7;
 If (Y1<>Y2) And (X1<>X2) Then
  Begin
   DX:=Abs(X2-X1);
   DY:=Abs(Y2-Y1);
   If (DX>dy) Then
     Begin
      If (X1>X2) Then
        Begin
         If Y1>Y2 Then step:=1 Else step:=-1;
         s:=X1;X1:=X2;X2:=s;Y1:=Y2;
        End
       Else
        If Y1<Y2 Then step:=1 Else step:=-1;
      If LineStyleType[LineStyle,ls]=1 Then PutPixel(X1,Y1,Color);
      Inc(ls);
      If ls>7 Then ls:=0;
      s:=DX Shr 1;
      Inc(X1);
      while(X1<=X2) Do
       Begin
        Dec(s,dy);
        If s<0 Then
         Begin
          Inc(s,DX);
          Inc(Y1,step);
         End;
        If LineStyleType[LineStyle,ls]=1 Then PutPixel(X1,Y1,Color);
        Inc(ls);
        If ls>7 Then ls:=0;
        Inc(X1);
       End;
     End
    Else
     Begin
      If (Y1>Y2) Then
        Begin
         If X1>X2 Then step:=1 Else step:=-1;
         s:=Y1;Y1:=Y2;Y2:=s;X1:=X2;
        End
       Else
        If X1<X2 Then step:=1 Else step:=-1;
      If LineStyleType[LineStyle,ls and 7]=1 Then PutPixel(X1,Y1,Color);
      Inc(ls);
      If ls>7 Then ls:=0;
      s:=dy Shr 1;
      Inc(Y1);
      while(Y1<=Y2) Do
       Begin
        Dec(s,DX);
        If s<0 Then
         Begin
          Inc(s,dy);
          Inc(X1,step);
         End;
        If LineStyleType[LineStyle,ls and 7]=1 Then PutPixel(X1,Y1,Color);
        Inc(ls);
        If ls>7 Then ls:=0;
        Inc(Y1);
       End;
     End
  End;
 freeMem(P,8);
End;

Procedure ClearScreen(Color:Byte); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov ES,VideoSeg
 Xor DI,DI
 Xor BL,BL
 Mov BH,MaxBank
@l1:
 Call SetWBank
 Mov AH,Color
 Mov AL,Color
 Mov CX,$8000
 Rep Stosw
 Inc BL
 Cmp BL,BH
 Jne @l1
@Q:
End;

Procedure BoxFill(X1,Y1,X2,Y2:Integer; Color:Byte); Assembler;
Var N,N2,YY:Word;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov BX,X1
 Cmp BX,MaxX
 Jge @Q
 Cmp BX,X2
 Je @Vlin
 Jl @CMX1
 Mov AX,X2
 Mov X2,BX
 Mov X1,AX
@CMX1:
 Cmp X1,0
 Jge @CMX2
 Mov X1,0
@CMX2:
 Cmp X2,0
 Jl @Q
 Mov AX,X2
 Cmp AX,MaxX
 Jl @CmYY
 Mov AX,MaxX
 Dec AX
 Mov X2,AX
@CMYY:
 Mov BX,Y1
 Cmp BX,MaxY
 Jge @Q
 Cmp BX,Y2
 Je @Hlin
 Jl @CMY1
 Mov AX,Y2
 Mov Y2,BX
 Mov Y1,AX
@CMY1:
 Cmp AX,0
 Jge @CMY2
 Mov Y1,0
@CMY2:
 Cmp Y2,0
 Jl @Q
 Mov AX,Y2
 Cmp AX,MaxY
 Jl @Put
 Mov AX,MaxY
 Dec AX
 Mov Y2,AX
@Put:
 Mov AX,X2
 Sub AX,X1
 Inc AX
 Mov N,AX
 Mov N2,AX
 Mov AX,Y2
 Sub AX,Y1
 Inc AX
 Mov YY,AX
 Mov AX,Y1
 Mul MaxX
 Add AX,X1
 Adc DX,0
 Mov ES,VideoSeg
 Mov DI,AX
 Mov BL,DL
 Mov AL,Color
 Call SetWBank
@Y:
 Mov AX,N2
 Mov N,AX
 Mov AX,DI
 Add AX,N
 Jc  @1
 Mov CX,N
 Mov AL,Color
 Rep Stosb
 Jmp @Next
@1:
 Mov AX,$FFFF
 Sub AX,DI
 Inc AX
 Sub N,AX
 Mov CX,AX
 Mov AL,Color
 Rep Stosb
 Inc BL
 Call SetWBank
 Mov CX,N
 Rep Stosb
@Next:
 Dec YY
 Je @Q
 Mov AX,MaxX
 Mov CX,DI
 Sub CX,N2
 Add CX,AX
 Mov DI,CX
 Jnc @Y
 Inc BL
 Call SetWbank
 Jmp @Y
@Vlin:
 Mov AX,Y1
 Push AX
 Mov AX,Y2
 Push AX
 Mov AL,Color
 Push AX
 Call Vline
 Jmp @Q
@Hlin:
 Mov AX,X1
 Push AX
 Mov AX,X2
 Push AX
 Mov AL,Color
 Push AX
 Call Hline
 Jmp @Q
@Q:
End;

Procedure Circle(X,Y,R:Integer;Color:Byte); Assembler;
Var
 X1,Y1:Integer;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov AX,R
 Mov X1,AX
 Xor AX,AX
 Mov Y1,AX
@1:
 Mov AX,X1
 Cmp AX,Y1
 Jl  @Q
 Mov AX,X
 Add AX,X1
 Push AX
 Mov AX,Y
 Add AX,Y1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
 Mov AX,X
 Add AX,X1
 Push AX
 Mov AX,Y
 Sub AX,Y1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
 Mov AX,X
 Sub AX,X1
 Push AX
 Mov AX,Y
 Add AX,Y1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
 Mov AX,X
 Sub AX,X1
 Push AX
 Mov AX,Y
 Sub AX,Y1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
 Mov AX,X
 Add AX,Y1
 Push AX
 Mov AX,Y
 Add AX,X1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
 Mov AX,X
 Add AX,Y1
 Push AX
 Mov AX,Y
 Sub AX,X1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
 Mov AX,X
 Sub AX,Y1
 Push AX
 Mov AX,Y
 Add AX,X1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
 Mov AX,X
 Sub AX,Y1
 Push AX
 Mov AX,Y
 Sub AX,X1
 Push AX
 Mov AL,Color
 Push AX
 Call PutPixel
 Mov AX,Y1
 Shl AX,1
 Inc AX
 Sub R,AX
 Inc Y1
 Cmp R,0
 Jge @2
 Mov AX,X1
 Dec AX
 Shl AX,1
 Add R,AX
 Dec X1
@2:
 Jmp @1
@Q:
End;

Procedure Circlef(X,Y,R:Integer;Color:Byte); Assembler;
Var
 X1,Y1:Integer;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov AX,R
 Mov X1,AX
 Xor AX,AX
 Mov Y1,AX
@1:
 Mov AX,X1
 Cmp AX,Y1
 Jl  @Q
 Mov BX,X
 Mov CX,X1
 Mov AX,BX
 Sub AX,CX
 Push AX
 Mov AX,BX
 Add AX,CX
 Push AX
 Mov AX,Y
 Sub AX,Y1
 Push AX
 Mov DL,Color
 Push DX
 Call HLine
 Mov BX,X
 Mov CX,X1
 Mov AX,BX
 Sub AX,CX
 Push AX
 Mov AX,BX
 Add AX,CX
 Push AX
 Mov AX,Y
 Add AX,Y1
 Push AX
 Mov DL,Color
 Push DX
 Call HLine
 Mov BX,X
 Mov CX,Y1
 Mov AX,BX
 Sub AX,CX
 Push AX
 Mov AX,BX
 Add AX,CX
 Push AX
 Mov AX,Y
 Sub AX,X1
 Push AX
 Mov DL,Color
 Push DX
 Call HLine
 Mov BX,X
 Mov CX,Y1
 Mov AX,BX
 Sub AX,CX
 Push AX
 Mov AX,BX
 Add AX,CX
 Push AX
 Mov AX,Y
 Add AX,X1
 Push AX
 Mov DL,Color
 Push DX
 Call HLine
 Mov AX,Y1
 Shl AX,1
 Inc AX
 Sub R,AX
 Inc Y1
 Cmp R,0
 Jge @2
 Mov AX,X1
 Dec AX
 Shl AX,1
 Add R,AX
 Dec X1
@2:
 Jmp @1
@Q:
End;

Procedure Ellipse(X,Y,RX,RY:Integer; Color:Byte);
Var
 X0,X1,Y0,Y1,R:Integer;
 D:Real;
Begin
 If Not Gmode Then Exit;
 If (RX>RY) Then
   Begin
    X0:=RX; R:=RX; Y0:=0;
    D:=RY/RX;
    while(X0>=Y0) Do
     Begin
      X1:=Trunc(X0*D);
      Y1:=Trunc(Y0*D);
      PutPixel(X+X0,Y+Y1,Color);
      PutPixel(X+X0,Y-Y1,Color);
      PutPixel(X-X0,Y+Y1,Color);
      PutPixel(X-X0,Y-Y1,Color);
      PutPixel(X+Y0,Y+X1,Color);
      PutPixel(X+Y0,Y-X1,Color);
      PutPixel(X-Y0,Y+X1,Color);
      PutPixel(X-Y0,Y-X1,Color);
      Asm
       Mov AX,Y0
       Shl AX,1
       Inc AX
       Sub R,AX
       Inc Y0
       Cmp R,0
       Jge @1
       Mov AX,X0
       Dec AX
       Shl AX,1
       Add R,AX
       Dec X0
@1:
      End;
     End;
   End
  Else
   Begin
    X0:=RY; R:=RY; Y0:=0;
    D:=RX/RY;
    while(X0>=Y0) Do
     Begin
      X1:=Trunc(X0*D);
      Y1:=Trunc(Y0*D);
      PutPixel(X+X1,Y+Y0,Color);
      PutPixel(X+X1,Y-Y0,Color);
      PutPixel(X-X1,Y+Y0,Color);
      PutPixel(X-X1,Y-Y0,Color);
      PutPixel(X+Y1,Y+X0,Color);
      PutPixel(X+Y1,Y-X0,Color);
      PutPixel(X-Y1,Y+X0,Color);
      PutPixel(X-Y1,Y-X0,Color);
      Asm
       Mov AX,Y0
       Shl AX,1
       Inc AX
       Sub R,AX
       Inc Y0
       Cmp R,0
       Jge @2
       Mov AX,X0
       Dec AX
       Shl AX,1
       Add R,AX
       Dec X0
@2:
      End;
     End;
   End;
End;

Procedure Ellipsef(X,Y,RX,RY:Integer; Color:Byte);
Var
 X0,Y0,X1,Y1,R:Integer;
 A1,A2,A3:Integer;
 D:Real;
Begin
 If Not Gmode Then Exit;
 If (RX>RY) Then
   Begin
    X0:=RX; R:=RX; Y0:=0;
    D:=RY/RX;
    while(X0>=Y0) Do
     Begin
      X1:=Trunc(X0*D);
      Y1:=Trunc(Y0*D);
      A1:=X-X0;A2:=X+X0;A3:=Y+Y1;
      HLine(X-X0,X+X0,Y+Y1,Color);
      HLine(X-X0,X+X0,Y-Y1,Color);
      HLine(X-Y0,X+Y0,Y+X1,Color);
      HLine(X-Y0,X+Y0,Y-X1,Color);
      Asm
       Mov AX,Y0
       Shl AX,1
       Inc AX
       Sub R,AX
       Inc Y0
       Cmp R,0
       Jge @1
       Mov AX,X0
       Dec AX
       Shl AX,1
       Add R,AX
       Dec X0
@1:
      End;
     End;
   End
  Else
   Begin
    X0:=RY; R:=RY; Y0:=0;
    D:=RX/RY;
    while(X0>=Y0) Do
     Begin
      X1:=Trunc(X0*D);
      Y1:=Trunc(Y0*D);
      HLine(X-X1,X+X1,Y+Y0,Color);
      HLine(X-X1,X+X1,Y-Y0,Color);
      HLine(X-Y1,X+Y1,Y+X0,Color);
      HLine(X-Y1,X+Y1,Y-X0,Color);
      Asm
       Mov AX,Y0
       Shl AX,1
       Inc AX
       Sub R,AX
       Inc Y0
       Cmp R,0
       Jge @2
       Mov AX,X0
       Dec AX
       Shl AX,1
       Add R,AX
       Dec X0
@2:
      End;
     End;
   End;
End;

Procedure Bezier3(X0,Y0,X1,Y1,X2,Y2:Integer; Color:Byte);
Var
 T:Real;
 LastX,LastY,X,Y:Integer;
Begin
 If Not Gmode Then Exit;
 LastX:=X0;
 LastY:=Y0;
 T:=0;
 Repeat
  T := T + 0.1;
  X:=Round(X0*(1-T)*(1-T)+X1*2*T*(1-T)+X2*T*T);
  Y:=Round(Y0*(1-T)*(1-T)+Y1*2*T*(1-T)+Y2*T*T);
  Line(LastX ,LastY ,X ,Y ,Color);
  LastX:=X;
  LastY:=Y
 Until T>=1.0
End;

Procedure Bezier4(X0,Y0,X1,Y1,X2,Y2,X3,Y3:Integer; Color:Byte);
Var
 T:Real;
 LastX,LastY,X,Y:Integer;
Begin
 If Not Gmode Then Exit;
 LastX:=X0;
 LastY:=Y0;
 T:=0;
 Repeat
  T := T + 0.1;
  X:=Round(X0*(1-T)*(1-T)*(1-T)+X1*3*T*(1-T)*(1-T)+X2*3*T*T*(1-T)+X3*T*T*T);
  Y:=Round(Y0*(1-T)*(1-T)*(1-T)+Y1*3*T*(1-T)*(1-T)+Y2*3*T*T*(1-T)+Y3*T*T*T);
  Line(LastX ,LastY ,X ,Y ,Color);
  LastX:=X;
  LastY:=Y
 Until T>=1.0
End;

Procedure Box(X1,Y1,X2,Y2:Integer; BoxCol:BoxType);
Var
 I,J:Integer;
Begin
 If Not Gmode Then Exit;
 If X1>X2 Then
  Begin
   I:=X1; X1:=X2; X2:=I;
  End;
 If Y1>Y2 Then
  Begin
   I:=Y1; X1:=Y2; Y2:=I;
  End;
 If ((X2-X1)<2) Or ((Y2-Y1)<2) Then Exit;
 I:=2;
 If (BoxCol.State And BoxThick)>0 Then  Inc(I,2);
 If (BoxCol.State And BoxShadow)>0 Then Begin Dec(X2,2); Dec(Y2,2); End;
 If (BoxCol.State And BoxInOut)=BoxInOut Then  Inc(I,8);
 If ((X2-X1)<I) Or ((Y2-Y1)<I) Then Exit;
 For J:=Y1+(I Shr 1) To Y2-(I Shr 1) Do
  Hline(X1+I Shr 1,X2-I Shr 1,J,BoxCol.Back);
 If (BoxCol.State And BoxInOut)=BoxInOut Then
   For J:=1 to 3 do
    Begin
     Hline(X1+J,X2-J,Y1+J,BoxCol.Med);
     Vline(Y1+J,Y2-J,X1+J,BoxCol.Med);
     Hline(X1+J,X2-J,Y2-J,BoxCol.Med);
     Vline(Y1+J,Y2-J,X2-J,BoxCol.Med);
    End
  Else
   If BoxCol.Med<>BoxCol.Back Then BoxCol.Lo:=BoxCol.Med;
 If (BoxCol.State And BoxOut)=0 Then
  Begin
   I:=BoxCol.Hi;
   BoxCol.Hi:=BoxCol.Lo;
   BoxCol.Lo:=I;
  End;
 If (BoxCol.State And BoxShadow)>0 Then
  Begin
   Hline(X1+1,X2,Y2+1,BoxCol.Shadow);
   Hline(X1+2,X2,Y2+2,BoxCol.Shadow);
   Vline(Y1+1,Y2+2,X2+1,BoxCol.Shadow);
   Vline(Y1+2,Y2+2,X2+2,BoxCol.Shadow);
  End;
 Hline(X1,X2,Y1,BoxCol.Hi);
 Vline(Y1,Y2,X1,BoxCol.Hi);
 Hline(X1+1,X2,Y2,BoxCol.Lo);
 Vline(Y1+1,Y2,X2,BoxCol.Lo);
 If (BoxCol.State And BoxThick)>0 Then
  Begin
   Dec(X2);   Dec(Y2);
   Hline(X1+2,X2,Y2,BoxCol.Lo);
   Vline(Y1+2,Y2,X2,BoxCol.Lo);
   If (BoxCol.State And BoxInOut)<>BoxInOut Then
    Begin
     Hline(X1,X2,Y1+1,BoxCol.Hi);
     Vline(Y1,Y2,X1+1,BoxCol.Hi);
     Inc(X1);   Inc(Y1);
    End;
  End;
 If (BoxCol.State And BoxInOut)=BoxInOut Then
  Begin
   Dec(X2,4);   Dec(Y2,4);
   Inc(X1,4);   Inc(Y1,4);
   Hline(X1,X2,Y1,BoxCol.Lo);
   Vline(Y1,Y2,X1,BoxCol.Lo);
   Hline(X1,X2,Y2,BoxCol.Hi);
   Vline(Y1,Y2,X2,BoxCol.Hi);
   If (BoxCol.State And BoxThick)>0 Then
    Begin
     Inc(X1);   Inc(Y1);
     Hline(X1,X2-1,Y1,BoxCol.Lo);
     Vline(Y1,Y2-1,X1,BoxCol.Lo);
    End;
  End;
End;

Procedure SRGB(Var P); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Xor AX,AX
 Mov DX,$3C8
 Out DX,AL
 Mov DX,$3C9
 Mov BX,DS
 Lds SI,P
 Mov CX,768
@J1:
 Lodsb
 Out DX,AL
 Loop @j1
 Mov DS,BX
@Q:
End;

Procedure GRGB(Var P); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Xor AL,AL
 Mov DX,$3C7
 Out DX,AL
 LES DI,P
 Mov CX,768
 Mov DX,$3C9
@L1:
 In AL,DX
 Stosb
 Loop @L1
@Q:
End;

Procedure PSRGB(ColorNum,Red,Green,Blue:Byte); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov DX,3C8h
 Mov AL,ColorNum
 Out DX,AL
 Mov DX,$3C9
 Mov AL,Red
 Out DX,AL
 Mov AL,Green
 Out DX,AL
 Mov AL,Blue
 Out DX,AL
@Q:
End;

Procedure PGRGB(ColorNum:Byte; Var Red,Green,Blue:Byte); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov DX,$3C7
 Mov AL,ColorNum
 Out DX,AL
 Mov DX,$3C9
 In AL,DX
 Les DI,Red
 Mov ES:[DI],AL
 In AL,DX
 Les DI,Green
 Mov ES:[DI],AL
 In AL,DX
 Les DI,Blue
 Mov ES:[DI],AL
@Q:
End;

Procedure BSRGB(ColorNum:Byte; Var Pal; CLen:Byte); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Push DS
 Push SI
 Mov DX,$3C8
 Mov AL,ColorNum
 Out DX,AL
 Xor CX,CX
 Xor AX,AX
 Mov AL,CLen
 Inc AL
 Mov CX,AX
 Shl AX,1
 Add CX,AX
 Lds SI,pal
 Mov DX,$3C9
@1:
 Lodsb
 Out DX,AL
 Loop @1
 Pop SI
 Pop DS
@Q:
End;

Procedure BGRGB(ColorNum:Byte; Var Pal; CLen:Byte); Assembler;
Asm
 Cmp Gmode,False;
 Je @Q
 Mov DX,$3C7
 Mov AL,ColorNum
 Out DX,AL
 Xor CX,CX
 Xor AX,AX
 Mov AL,CLen
 Inc AL
 Mov CX,AX
 Shl AX,1
 Add CX,AX
 Les DI,pal
 Mov DX,$3C9
@1:
 In AL,DX
 Stosb
 Loop @1
@Q:
End;

Procedure WRGB(FileName:String;P:PaletteType);
Var
 F:File of PaletteType;
Begin
 Assign(F,FileName);
 ReWrite(F);
 Write(F,P);
 Close(F);
End;

Procedure RRGB(FileName:String; Var P:PaletteType);
Var
 F:File of PaletteType;
Begin
 Assign(F,FileName);
 Reset(F);
 Read(F,P);
 Close(F);
End;

Procedure Gray(Var P1,P2:PaletteType); Assembler;
Asm
 Push DS
 Push SI
 Mov CX,$100
 Les DI,P1
 Lds SI,P2
@1:
 Lodsb
 Mov AH,AL
 Lodsb
 ADD AH,AL
 Lodsb
 ADD AH,AL
 Mov AL,AH
 Mov AH,0
 Mov BL,3
 Div BL
 Stosb
 Stosb
 Stosb
 Dec CX
 Cmp CX,0
 Jne @1
 Pop SI
 Pop DS
End;

Procedure Grade(Sc,Ec:Byte; Var P:PaletteType);
Var
 I,J:Word;
 Q1,Q2,Q3,R1,R2,R3:Integer;
Begin
 If Ec<Sc Then Begin I:=Ec; Ec:=Sc; Sc:=I; End;
 Q1:=Palette[Ec*3];
 Q2:=Palette[Ec*3+1];
 Q3:=Palette[Ec*3+2];
 R1:=Palette[Sc*3]-Palette[Ec*3];
 R2:=Palette[Sc*3+1]-Palette[Ec*3+1];
 R3:=Palette[Sc*3+2]-Palette[Ec*3+2];
 J:=Ec-Sc;
 For I:=Sc+1 To Ec-1 DO
  Begin
   Palette[I*3  ]:=Q1+Trunc((R1/J)*(Ec-I));
   Palette[I*3+1]:=Q2+Trunc((R2/J)*(Ec-I));
   Palette[I*3+2]:=Q3+Trunc((R3/J)*(Ec-I));
  End;
End;

Procedure Fade(P:FadeIO);
Var
 I,J,R1,G1,B1:Byte;
 Pal:PaletteType;
 De:Array[0..255] Of Record
                      R,G,B:Real;
                      R1,G1,B1:Shortint;
                     End;
Begin
 GRGB(PAL);
 For J:=P.SNum TO P.ENum DO
  Begin
   If Pal[J*3]>P.Pal[j*3] Then
     Begin De[j].R:=(Pal[j*3]-P.Pal[j*3])/P.Cycle; De[j].R1:=-1; End
    Else Begin De[j].R:=(P.Pal[j*3]-Pal[j*3])/P.Cycle; De[j].R1:=1; End;
   If Pal[J*3+1]>P.Pal[j*3+1] Then
     Begin De[j].G:=(Pal[j*3+1]-P.Pal[j*3+1])/P.Cycle; De[j].G1:=-1; End
    Else Begin De[j].G:=(P.Pal[j*3+1]-Pal[j*3+1])/P.Cycle; De[j].G1:=1; End;
   If Pal[J*3+2]>P.Pal[j*3+2] Then
     Begin De[j].B:=(Pal[j*3+2]-P.Pal[j*3+2])/P.Cycle; De[j].B1:=-1; End
    Else Begin De[j].B:=(P.Pal[j*3+2]-Pal[j*3+2])/P.Cycle; De[j].B1:=1; End;
  End;
 For I:=1 To P.Cycle Do
  Begin
   For J:=P.SNum TO P.ENum DO
    Begin
     R1:=Pal[j*3]+Shortint(Trunc(De[j].R*i)*De[j].R1);
     G1:=Pal[j*3+1]+Shortint(Trunc(De[j].G*i)*De[j].G1);
     B1:=Pal[j*3+2]+Shortint(Trunc(De[j].B*i)*De[j].B1);
     PSRGB(J,R1,G1,B1);
     If (Keypressed) And (P.KeyPres) Then
      Begin
       For I:=P.SNum TO P.ENum Do
        PSRGB(I,P.Pal[i*3],P.Pal[i*3+1],P.Pal[i*3+2]);
       Exit;
      End;
    End;
  End;
End;

Procedure FadeToPal(P:FadeIO);
Var
 I,J,R1,G1,B1:Byte;
 Pal:PaletteType;
 De:Array[0..255] Of Record
                      R,G,B:Real;
                      R1,G1,B1:Shortint;
                     End;
Begin
 GRGB(PAL);
 For J:=P.SNum TO P.ENum DO
  Begin
   If Pal[J*3]>P.R Then
     Begin De[j].R:=(Pal[j*3]-P.R)/P.Cycle; De[j].R1:=-1; End
    Else Begin De[j].R:=(P.R-Pal[j*3])/P.Cycle; De[j].R1:=1; End;
   If Pal[J*3+1]>P.G Then Begin De[j].G:=(Pal[j*3+1]-P.G)/P.Cycle; De[j].G1:=-1; End
    Else Begin De[j].G:=(P.G-Pal[j*3+1])/P.Cycle; De[j].G1:=1; End;
   If Pal[J*3+2]>P.B Then Begin De[j].B:=(Pal[j*3+2]-P.B)/P.Cycle; De[j].B1:=-1; End
    Else Begin De[j].B:=(P.B-Pal[j*3+2])/P.Cycle; De[j].B1:=1; End;
  End;
 For I:=1 To P.Cycle Do
  Begin
   For J:=P.SNum TO P.ENum DO
    Begin
     R1:=Pal[j*3]+Shortint(Trunc(De[j].R*i)*De[j].R1);
     G1:=Pal[j*3+1]+Shortint(Trunc(De[j].G*i)*De[j].G1);
     B1:=Pal[j*3+2]+Shortint(Trunc(De[j].B*i)*De[j].B1);
     PSRGB(J,R1,G1,B1);
     If (Keypressed) And (P.KeyPres) Then
      Begin
       For I:=P.SNum TO P.ENum Do
        PSRGB(I,P.R,P.G,P.B);
       Exit;
      End;
    End;
  End;
End;

Procedure ConvPalette(Var Pp1,Pp2:PaletteType; Var Conv:ConvType);
Var
 I,J:Word;
 P1,P2:rgbType;
 R,G,B,C,R1,G1,B1,Pa1,Pa2:Byte;
Begin
 Move(Pp1,P1,768);
 Move(Pp2,P2,768);
 For I:=0 to 255 Do
  Begin
   R1:=255; G1:=255; B1:=255; C:=0; Pa1:=255; J:=0;
   Repeat
    R:=Abs(p1[I].R-p2[J].R);
    G:=Abs(p1[I].G-p2[J].G);
    B:=Abs(p1[I].B-p2[J].B);
    pa2:=(R+G+B) Div 3;
    If (pa1>pa2) And ((r1>R) Or (g1>G) Or (b1>B)) Then
     Begin
      r1:=R;g1:=G;b1:=B;
      C:=J;
      pa1:=pa2;
     End;
    Inc(J);
  until ((r1<5) And (g1<5) And (b1<5)) Or (J=256);
  conv[I]:=C;
  If ((r1>5) Or (g1>5) Or (b1>5)) And (NulColor<255) Then
   Begin
    p2[NulColor].R:=p1[I].R;
    p2[NulColor].G:=p1[I].G;
    p2[NulColor].B:=p1[I].B;
    If SetConvertPalette Then psrgb(NulColor,p1[I].R,p1[I].G,p1[I].B);
    pp2[NulColor*3]:=p1[I].R;
    pp2[NulColor*3+1]:=p1[I].G;
    pp2[NulColor*3+2]:=p1[I].B;
    conv[I]:=NulColor;
    Inc(NulColor);
   End;
 End;
End;

Procedure cbB(Var A,B;C:Byte; Size:Word); Assembler;
Asm
 Push ES
 Push DI
 Push DS
 Push SI
 Lds SI,A
 Les DI,B
@lop1:
 Lodsb
 Mov BH,al
 Mov BL,$80
 Mov CX,8
@0:
 Mov AL,BH
 And AL,BL
 Je  @1
 Mov AL,C
 Jmp @2
@1:
 Mov AL,0
@2:
 Stosb
 Shr BL,1
 Loop @0
 Dec Size
 Jne @lop1
 Pop SI
 Pop DS
 Pop DI
 Pop ES
End;

Procedure c16bB(Var A,B; bpl,Size:Word); Assembler;
Asm
 Push ES
 Push DI
 Push DS
 Push SI
 Mov DX,bpl
 Lds SI,A
 Les DI,B
@lop1:
 Mov BL,$80
 Mov CX,8
@0:
 Xor AH,AH
 Mov BH,DS:[SI]
 And BH,BL
 Je @1
 Mov AH,1
@1:
 Add SI,DX
 Mov BH,DS:[SI]
 And BH,BL
 Je @2
 Or AH,2
@2:
 Add SI,DX
 Mov BH,DS:[SI]
 And BH,BL
 Je @3
 Or AH,4
@3:
 Add SI,DX
 Mov BH,DS:[SI]
 And BH,BL
 Je @4
 Or AH,8
@4:
 Sub SI,DX
 Sub SI,DX
 Sub SI,DX
 Mov AL,AH
 Stosb
 Shr BL,1
 Loop @0
 Inc SI
 Dec Size
 Jne @lop1
 Pop SI
 Pop DS
 Pop DI
 Pop ES
End;

Procedure PcxSlow(FileName:String; X,Y,X1,Y1,X2,Y2:Integer; Var P:PaletteType);
Var
 F:File;
 I,J,K:Word;
 i3:Word;
 Size,po:LongInt;
 L,N:Byte;
 PcxHeader:PcxHDR;
 GBlockBuffer:Array[0..1023] of Byte;
 PutData,PutData2:Array[0..1023] of Byte;
 P2:PaletteType;
Begin
 If Not Gmode Then Exit;
 If X1<0 Then X1:=0;
 If Y1<0 Then Y1:=0;
 If X<0 Then Begin X1:=X1+X; X:=0; End;
 If Y<0 Then Begin Y1:=Y1+Y; Y:=0; End;
{$I-}
 Assign(F,FileName);
 Reset(F,1);
{$I+}
 PcxReadError:=False;
 If IOResult>0 Then Begin PcxReadError:=True; Exit; End;
 BlockRead(F,PcxHeader,Sizeof(Pcxhdr));
 Size:=FiLeSize(F);
 Dec(PcxHeader.BytesperLine);
 PcxHeader.X1:=X; PcxHeader.Y1:=Y;
 If X2>PcxHeader.X2 Then X2:=PcxHeader.X2;
 If Y2>PcxHeader.Y2 Then Y2:=PcxHeader.Y2 Else PcxHeader.Y2:=Y2;
 case PcxHeader.BitsPerPixel of
  8:Begin
     Seek(F,Size-768);
     BlockRead(F,P,768);
     _BlockShr(P,768,2);
     GRGB(p2);
     If ConvertPalette=False Then
       Begin
        If SetGrayPalette Then Gray(P,P);
        If SetRGBPalette Then SRGB(P);
       End
      Else
       Begin
        ConvPalette(P,p2,ConvertP);
        If SetRGBPalette Then SRGB(P);
       End;
    End;
  1:If PcxHeader.nplanes=4 Then
     Begin
      grgb(P);
      _BlockShr(PcxHeader.palette16,48,2);
      Move(PcxHeader.palette16,P,48);
      If SetGrayPalette Then Gray(P,P);
      If SetRGBPalette Then SRGB(P);
      SRGB(P);
      i3:=PcxHeader.BytesperLine+1;
      PcxHeader.BytesperLine:=PcxHeader.BytesperLine Shl 2+3;
     End;
  End;
 X:=0; Y:=0; K:=X2-X1+1; J:=0; po:=128;
 Seek(f,po);
 If Size<po+1024 Then
   BlockRead(F,GBlockBuffer,Size-po)
  Else
    BlockRead(F,GBlockBuffer,1024);
 N:=gBlockBuffer[J];
 Repeat
  If N>$c0 Then
    Begin
     Inc(J);
     L:=gBlockBuffer[J];
     If (ConvertPalette) And (PcxHeader.BitsPerPixel=8) Then L:=ConvertP[L];
     _FillByte(PutData[X],N And $3f,L);
     Inc(X,N And $3f);
    End
   Else
    Begin
     If (ConvertPalette) And (PcxHeader.BitsPerPixel=8) Then N:=ConvertP[N];
     PutData[X]:=N;
     Inc(X);
    End;
  Inc(J);
  If X>PcxHeader.BytesperLine Then
   Begin
    X:=0;
    If Y>=Y1 Then
     case PcxHeader.BitsPerPixel of
      8: LinePut(PcxHeader.X1,PcxHeader.Y1+Y,PutData[X1],K);
      1: case PcxHeader.nplanes of
          4: Begin
              c16bb(PutData,PutData2,i3,PcxHeader.BytesperLine Shr 2+1);
              LinePut(PcxHeader.X1,PcxHeader.Y1+Y,PutData2[X1],K);
             End;
          1: Begin
              cbb(PutData,PutData2,$0f,PcxHeader.BytesperLine+1);
              LinePut(PcxHeader.X1,PcxHeader.Y1+Y,PutData2[X1],K);
             End;
         End;
     End;
    Inc(Y);
   End;

  If J>1020 Then
   Begin
    J:=J-1021;
    Inc(po,1021);
    Seek(f,po);
    If Size<po+1024 Then
      BlockRead(F,GBlockBuffer,Size-po)
     Else
      BlockRead(F,GBlockBuffer,1024);
   End;
  N:=gBlockBuffer[J];
 Until (Y>PcxHeader.Y2) Or (Y>MaxY);
 Close(F);
End;

Procedure PcxHeader(FileName:String;Var Header:Pcxhdr);
Var
 F:File;
Begin
{$I-}
 Assign(f,FileName);
 Reset(f,1);
{$I+}
 PcxReadError:=False;
 If IOResult>0 Then Begin PcxReadError:=True; Exit; End;
 BlockRead(f,Header,Sizeof(Pcxhdr));
 Close(f);
End;

Procedure PcxColor(FileName:String;Var Color:PaletteType);
Var
 F:File;
 H:PcxHdr;
Begin
 PcxHeader(FileName,H);
 If PcxReadError=True Then Exit;
 If H.BitsPerPixel=8 Then
   Begin
    Assign(F,FileName);
    ReSet(F);
    Seek(F,FileSize(F)-768);
    BlockRead(F,Color,768);
    Close(F);
   End
  Else
   If H.NPlanes=4 Then Move(H.Palette16,Color[0],48)
    Else
     Begin
      Color[0]:= 0; Color[1]:= 0; Color[2]:= 0;
      Color[3]:=63; Color[4]:=63; Color[5]:=63;
     End;
End;

Procedure HmyFont; External;
{$l Hanmy.obj}

Procedure EmyFont; External;
{$l myungjo.obj}

Procedure LoadEng(n:Byte; p:Pointer);
Begin
 Move(P^,Etype(EngFont^)[n],4096);
End;

Procedure LoadHan(n:Byte; p:Pointer);
Type
 F=Array[0..11520] OF Byte;
Begin
 Move(F(P^)[0],FType(HanFontF^)[N],5120);
 Move(F(P^)[5120],SType(HanFontS^)[N],2816);
 Move(F(P^)[7936],TTYpe(HanFontT^)[N],3584);
End;

Procedure Puttext(x,y,Del:Integer; stri:String);
Const
NulFont: FontType =
      ($00,$00,$7F,$FE,$60,$06,$50,$0A,$48,$12,$44,$22,$42,$42,$41,$82,
       $41,$82,$42,$42,$44,$22,$48,$12,$50,$0A,$60,$06,$7F,$FE,$00,$00);
HanTable : Array[1..3, 0..31] of Byte =
           ((00, 00, 01, 02, 03, 04, 05, 06, 07, 08, 09, 10, 11, 12, 13, 14,
             15, 16, 17, 18, 19, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00),
            (00, 00, 00, 01, 02, 03, 04, 05, 00, 00, 06, 07, 08, 09, 10, 11,
             00, 00, 12, 13, 14, 15, 16, 17, 00, 00, 18, 19, 20, 21, 00, 00),
            (00, 00, 01, 02, 03, 04, 05, 06, 07, 08, 09, 10, 11, 12, 13, 14,
             15, 16, 00, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 00, 00));
MidTable1 : Array[0..21] of Byte =
            (0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0,  
             2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1); 
FstTable1 : Array[0..19] of Byte =
            (0, 0, 1, 1, 1, 1, 1, 1, 1, 1,     
             1, 1, 1, 1, 1, 1, 0, 1, 1, 1);    
FstTable2 : Array[0..19] of Byte =
            (0, 2, 3, 3, 3, 3, 3, 3, 3, 3,     
             3, 3, 3, 3, 3, 3, 2, 3, 3, 3);    
MidTable2 : Array[0..21] of Byte =
            (0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3,  
             3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0); 
MidTable3 : Array[0..21] of Byte =
            (0, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7,  
             7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5); 
BitM:Array[0..7] of Byte =($80,$40,$20,$10,$08,$04,$02,$01);
Var
 f1,f2,s1,s2,t1,t2:Byte;
 i,j:Byte;
 n,H,skipx:Word;
 PutData,PD:Array[0..15,1..256] Of Byte;
 Li:Array[0..1024] Of Byte;
 Hd:Fonttype;
 F:File;
 P:Longint;
 NewH:Boolean;

 Procedure cbB(Var a,b;c,d,e:Byte; Size:Word); Assembler;
 Asm
  Push ES
  Push DI
  Push DS
  Push SI
  Lds SI,a
  Les DI,b
@lop1:
  Lodsb
  Mov BH,al
  Mov BL,$80
  Mov CX,8
@0:
  Mov AL,bh
  And AL,bl
  Je  @1
  Mov AL,c
  Jmp @2
@1:
  Mov AL,d
@2:
  Push CX
  Xor Cx,Cx
  Mov Cl,e
  Rep Stosb
  Pop Cx
  Shr BL,1
  Loop @0
  Dec Size
  Jne @lop1
  Pop SI
  Pop DS
  Pop DI
  Pop ES
 End;

Begin
 i:=FontStyle.Width Shl 3;
 skipx:=0;
 n:=Ord(stri[0])*i - skipx;
 If n>1023 Then
  Begin
   Repeat
    stri[0]:=chr(Ord(stri[0])-1);
    n:=Ord(stri[0])*i;
   until n<1024;
  End;
 For i:=1 to Ord(stri[0]) Do
  If (FontStyle.OnlyEng) Or ((Ord(stri[i]) And $80)=0) Then
    For j:=0 to 15 Do
     Putdata[j,i]:=EType(EngFont^)[FontStyle.EngFont][Ord(stri[i]),j]
   Else
    Begin
     Case Stri[I] Of
      #$D4:If (Stri[I+1]<#$80) And (HSFontF) Then  { ﺸ Ư }
             _MovEW(HsType(HanSpeFont^)[Ord(Stri[I+1])],Hd,16)
            Else
             _MovEW(NulFont,Hd,16);
      #$D9..#$DE:If SpecialFontF Then
                   Begin
                    h:=Ord(Stri[i])-$D9;
                    If Stri[I+1]<=#$7e Then Inc(H,Ord(Stri[I+1])-$31)
                     Else Inc(H,Ord(Stri[I+1])-67);
                    _MovEW(SpeType(SpeFont^)[Ord(Stri[I+1])],Hd,16);
                   End
                  Else
                  _MovEW(NulFont,Hd,16);
      #$E0..#$F9:If (FontStyle.UseHanJa) And (HanJaFontF) Then
                   Begin
                    NewH:=True;
                    If HanjaCodes>0 Then
                     For h:=0 To HanJaCodes-1 Do
                      If HanjaType(HanJa^)[h].Code=Ord(stri[i]) shl 8 +Ord(Stri[i+1]) Then
                       Begin
                        _MovEW(HanJaType(HanJa^)[H].Hd,Hd,16);
                        NewH:=False;
                       End;
                    If NewH Then
                     Begin
                      Assign(F,HanJaFont);
                      ReSet(f,1);
                      p:=(Ord(stri[i])-$e0)*188;
                      If Ord(stri[i+1])<=$7E Then Inc(p,Ord(stri[i+1])-$31)
                       Else inc(p,Ord(stri[i+1])-67);
                      p:=p Shl 5+HjHeader;
                      Seek(F,p);
                      BlockRead(f,HanJaType(HanJa^)[HanjaCodes].HD,Sizeof(Fonttype));
                      _MoveW(HanJaType(HanJa^)[HanJaCodes].Hd,Hd,16);
                      Close(f);
                      HanJaType(HanJa^)[HanJaCodes].Code:=Ord(stri[i]) shl 8 +Ord(Stri[i+1]);
                      If HanjaCodes<511 Then Inc(HanjaCodes);
                     End;
                   End
                  Else
                   _MovEW(NulFont,Hd,16);
      #$84..#$D3:Begin
                  f1:=Hantable[1,(Ord(stri[i]) Shr 2) And $1f];
                  s1:=Hantable[2,((Ord(stri[i]) Shl 3)+
                                 (Ord(stri[i+1]) Shr 5)) And $1f];
                  t1:=Hantable[3,Ord(stri[i+1]) And $1f];
                  t2:=Midtable1[s1];
                  If T1=0 Then
                    Begin
                      s2:=fsttable1[f1];
                      f2:=midtable2[s1];
                    End
                   Else
                    Begin
                     s2:=fsttable2[f1];
                     f2:=midtable3[s1];
                    End;
                  _MovEW(FType(HanFontF^)[FontStyle.HanFont][f2,f1],HD,16);
                  _OrMovEW(SType(HanFontS^)[FontStyle.HanFont][s2,s1],HD,16);
                  _OrMovEW(TType(HanFontT^)[FontStyle.HanFont][t2,t1],HD,16);
                 End;
       Else _MovEW(NulFont,Hd,16);
      End;
     For j:=0 to 31 Do
      If J And 1 =0 Then Putdata[j Shr 1,i]:=HD[J]
       Else Putdata[j Shr 1,i+1]:=HD[J];
     Inc(i);
    End;
(*
 If FontStyle.State And Um=0 Then _FillWord(PD,8192,0,0)
  Else _FillWord(PD,8192,$AA,$AA);
 If FontStyle.State And OutLine>0 Then
  For i:=0 To 14 Do
   Begin
    MoveW(PutData[i+1],Li,128);
    BlockShl(Li,1024,1);
    BlockShr(PutData[i],256,1);
    MoveOr(Li,PutData[i],128);
   End;
 _OrMoveW(PD,PutData,8192);
 If FontStyle.State And OutLine>0 Then
*)
  For I:=0 to 15 Do
   Begin
     delay(Del);
   If FontStyle.State And Bold>0 Then
     Begin
      _MoveW(PutData[i],Li,128);
      _BlockShl(Li,256,1);
      _OrMoveW(Li,PutData[i],128);
     End;
    If (FontStyle.State And $18>0) And ((i=1) Or (i=14)) Then
      CBB(PutData[I],Li,FontStyle.Color,FontStyle.LineColor,
                                        FontStyle.Width,Ord(Stri[0]))
     Else
      CBB(PutData[I],Li,FontStyle.Color,FontStyle.Bcolor,
                                        FontStyle.Width,Ord(Stri[0]));

    For j:=1 to FontStyle.Height Do
     Begin
      If y>=Maxy Then exit;
      If y>=0 Then LinePut(x,y,li,n);
      Inc(y);
     End;
   End;
End;

Procedure RHanFont(N:Byte; Name:String);
Var
 F:File;
 S:Longint;
 H:String[32];
 P:Pointer;
Begin
 {$I-}
 Assign(F,Name);
 ReSet(F,1);
 {$I+}
 If Ioresult>0 Then
  Begin
   ReadFontError:=SizeNotMatch;
   Exit;
  End;
 S:=Filesize(F);
 BlockRead(f,H[1],32);
 If Copy(H,1,15)='HWP Font Editor' Then
  Begin Seek(F,32); Dec(s,32); End Else Seek(f,0);
 If S=11520 Then
  Begin
   GetMem(P,11520);
   BlockRead(F,P^,11520);
   LoadHan(N,P);
   FreeMem(P,11520);
  End Else ReadFontError:=SizeNotMatch;
 Close(F);
End;

Procedure RHSpeFont(Name:String);
Var
 F:File;
 S:Longint;
 H:String[32];
Begin
 {$I-}
 Assign(F,Name);
 ReSet(F,1);
 {$I+}
 If Ioresult>0 Then
  Begin
   ReadFontError:=SizeNotMatch;
   Exit;
  End;
 S:=Filesize(F);
 BlockRead(f,H[1],32);
 If Copy(H,1,15)='HWP Font Editor' Then
  Begin Seek(F,32); Dec(s,32); End Else Seek(f,0);
 If S=4096 Then
   Begin
    BlockRead(F,HanSpeFont^,4096);
    HSFontF:=True;
   End
  Else ReadFontError:=SizeNotMatch;
 Close(F);
End;

Procedure REngFont(N:Byte; Name:String);
Var
 F:File;
 S:Longint;
 H:String[32];
 P:Pointer;
Begin
 {$I-}
 Assign(F,Name);
 ReSet(F,1);
 {$I+}
 If Ioresult>0 Then
  Begin
   ReadFontError:=SizeNotMatch;
   Exit;
  End;
 S:=Filesize(F);
 BlockRead(f,H[1],32);
 If Copy(H,1,15)='HWP Font Editor' Then
  Begin Seek(F,32); Dec(s,32); End Else Seek(f,0);
 If S>2047 Then
  Begin
   GetMem(P,S);
   BlockRead(F,P^,S);
   LoadEng(N,P);
   FreeMem(P,S);
  End Else ReadFontError:=SizeNotMatch;
 Close(F);
End;

Procedure RSpeFont(Name:String);
Var
 F:File;
 S:Longint;
 H:String[32];
 P:Pointer;
Begin
 {$I-}
 Assign(F,Name);
 ReSet(F,1);
 {$I+}
 If Ioresult>0 Then
  Begin
   ReadFontError:=SizeNotMatch;
   Exit;
  End;
 S:=Filesize(F);
 BlockRead(f,H[1],32);
 If Copy(H,1,15)='HWP Font Editor' Then
  Begin Seek(F,32); Dec(s,32); End Else Seek(f,0);
 If S>37791 Then
  Begin
   BlockRead(F,Spefont^,S);
   SpecialFontF:=True;
  End Else ReadFontError:=SizeNotMatch;
 Close(F);
End;

Procedure RHjFont(Name:String);
Var
 F:File;
 S:Longint;
 H:String[32];
 P:Pointer;
Begin
 {$I-}
 Assign(F,Name);
 ReSet(F,1);
 {$I+}
 If Ioresult>0 Then
  Begin
   ReadFontError:=SizeNotMatch;
   Exit;
  End;
 S:=Filesize(F);
 BlockRead(f,H[1],32);
 If Copy(H,1,15)='HWP Font Editor' Then
  Begin
   HjHeader:=32; Dec(S,32);
  End
   Else HjHeader:=0;
 If S=156416 Then
  Begin
   HanJaFont:=Name;
   HanJaFontF:=True;
   FontStyle.UseHanja:=True;
  End Else ReadFontError:=SizeNotMatch;
 Close(F);
End;

Function _ToHex(A:Word):String;
Const
 Va:String[16]='0123456789ABCDEF';
Begin
 _ToHex:=Va[(Hi(A) Shr 4) And $0f +1] + Va[Hi(A) And $0f +1] +
         Va[(Lo(A) Shr 4) And $0f +1] + Va[Lo(A) And $0f +1];
End;

Function _ByteToBin(B:Byte):String;
Var
 S:String;
 I,J:Byte;
Begin
 S:='';J:=128;
 For I:=1 To 8 do
  Begin
   If (B And J)>0 Then S:=S+'1' Else S:=S+'0';
   J:=J Shr 1;
  End;
 _ByteToBin:=S;
End;

Function _BinToByte(B:String):Byte;
Var
 I,J,K:Byte;
Begin
 J:=128;K:=0;
 For I:=1 To 8 do
  Begin
   If B[I]='1' Then K:=K Or J;
   J:=J Shr 1;
  End;
 _BinToByte:=K;
End;

Procedure _KeySpeed(KDelay,KRate:byte); Assembler;
Asm
 Mov AH,03
 Mov AL,05
 Mov BH,KDelay
 Mov BL,KRate
 Int $16
End;

Procedure _CursorSize(StL,EnL:Byte); Assembler;
Asm
 Mov AH,1
 Mov CH,StL
 Mov CL,EnL
 Int $10
End;

Procedure _AutoBye(So,Wai:Word); Assembler;
Asm
 In AL,$61
 Mov CX,So
@1:
 Xor AL,2
 Out $61,AL
 Push CX
 ADD CX,Wai
@2:
 Loop @2
 Pop CX
 Loop @1
 And AL,$FC
 Out $61,AL
End;

Procedure _MSound(Count:Word); Assembler;
Asm
 In AL,$61
 Or AL,3
 Out $61,AL
 Mov AL,50
@1:
 Out $42,AL
 Mov CX,Count
@2:
 Loop @2
 Dec AL
 Jnz @1
 In AL,$61
 And AL,Not $3
 Out $61,AL
End;

Procedure _BlockShl(Var Block; Size:Word; LeftShift:Byte); Assembler;
Asm
 Push DS
 Push SI
 Les DI,Block
 Lds SI,Block
 Mov AX,Size
 Mov CX,AX
 Xor DH,DH
 Mov DL,LeftShift
@Loop1:
 Lodsb
 Mov BX,CX
 Mov CX,DX
 Shl AL,CL
 Mov CX,BX
 Stosb
 Loop @Loop1
 Pop SI
 Pop DS
End;

Procedure _BlockShr(Var Block; Size:Word; RightShift:Byte); Assembler;
Asm
 Push DS
 Push SI
 Les DI,Block
 Lds SI,Block
 Mov AX,Size
 Mov CX,AX
 Xor DH,DH
 Mov DL,RightShift
@Loop1:
 Lodsb
 Mov BX,CX
 Mov CX,DX
 Shr AL,CL
 Mov CX,BX
 Stosb
 Loop @Loop1
 Pop SI
 Pop DS
End;

Procedure _BlockDec(Var Block; Size:Word; Decrement:Byte); Assembler;
Asm
 Push DS
 Push SI
 Les DI,Block
 Lds SI,Block
 Mov AX,Size
 Mov CX,AX
 Mov DL,Decrement
@Loop1:
 Lodsb
 Sub AL,DL
 Stosb
 Loop @Loop1
 Pop SI
 Pop DS
End;

Procedure _BlockInc(Var Block; Size:Word; Increment:Byte); Assembler;
Asm
 Push DS
 Push SI
 Les DI,Block
 Lds SI,Block
 Mov AX,Size
 Mov CX,AX
 Mov DL,Increment
@Loop1:
 Lodsb
 Add AL,DL
 Stosb
 Loop @Loop1
 Pop SI
 Pop DS
End;

Procedure _FillByte(var block; Count:Word; OutPutData:Byte); assembler;
Asm
 Les DI,block
 Mov CX,Count
 Mov AL,outputdata
 Rep Stosb
End;

Procedure _FillWord(var block; Count:Word; Hi,Lo:Byte); Assembler;
Asm
 Les DI,block
 Mov CX,Count
 Mov AH,Hi
 Mov AL,Lo
 Rep Stosw
End;

Procedure _FillBytep(S,O:Word; Count:Word; OutPutData:Byte); assembler;
Asm
 Mov ES,s
 Mov DI,o
 Mov CX,Count
 Mov AL,outputdata
 Rep Stosb
End;

Procedure _FillWordp(s,o:Word; Count:Word; Hi,Lo:Byte); Assembler;
Asm
 Mov ES,s
 Mov DI,o
 Mov CX,Count
 Mov AH,Hi
 Mov AL,Lo
 Rep Stosw
End;

Procedure _MoveW(Var A,B; N:Word); Assembler;
Asm
 Push DS
 Push SI
 Lds SI,a
 Les DI,b
 Mov CX,n
 rep Movsw
 Pop SI
 Pop DS
End;

Procedure _OrMoveW(Var A,B; N:Word); Assembler;
Asm
 Push DS
 Push SI
 Lds SI,a
 Les DI,b
 Mov CX,n
@1:
 Lodsw
 Mov BX,ES:[DI]
 Or AX,BX
 Stosw
 Loop @1
 Pop SI
 Pop DS
End;

Procedure _GetFont(Code:Byte; Var Table; Count:Byte);
Var
 Generator:Pointer;
Begin
 PortW[$3C4]:=$0704;
 PortW[$3CE]:=$0204;
 PortW[$3CE]:=$0005;
 PortW[$3CE]:=$0406;
 Generator:=Ptr($A000,Code shl 5);
 Move(Generator^,Table,Count);
 PortW[$3C4]:=$0304;
 PortW[$3CE]:=$0004;
 PortW[$3CE]:=$1005;
 PortW[$3CE]:=$0E06;
End;

Procedure _SetFont(Code:Byte; Var Table; Count:Byte);
Var
 Generator:Pointer;
Begin
 PortW[$3C4]:=$0402;
 PortW[$3C4]:=$0704;
 PortW[$3CE]:=$0005;
 PortW[$3CE]:=$0406;
 Generator:=Ptr($A000,Code shl 5);
 Move(Table,Generator^,Count);
 PortW[$3C4]:=$0302;
 PortW[$3C4]:=$0304;
 PortW[$3CE]:=$1005;
 PortW[$3CE]:=$0E06;
End;

Function ReadCmos(Addr:Byte):Byte; Assembler;
Asm
 Cli
 Mov AL,Addr
 Out $70,AL
 In  AL,$71
 Sti
End;

Procedure WriteCmos(Addr,Data:Byte); Assembler;
Asm
 Cli
 Mov AL,Addr
 Out $70,AL
 Mov AL,Data
 Out $71,AL
 Sti
End;

Function UnBCD(S:Byte):Byte; Assembler;
Asm
 Xor AX,AX
 Mov AL,S
 Mov BL,AL
 And BL,$0F
 And AL,$F0
 Mov AH,AL
 Shr AL,1
 Shr AH,3
 Add AL,AH
 Add AL,BL
End;

Function ToBCD(S:Byte):Byte;
Begin
 ToBCD:=(S Div 10) Shl 4 + (S Mod 10);
End;

Procedure GetTime(Var Hour,Min,Sec,Date:Byte);
Begin
 Hour:=UnBCD(ReadCmos(4));
 Min:=UnBCD(ReadCmos(2));
 Sec:=UnBCD(ReadCmos(0));
 Date:=UnBCD(ReadCmos(6));
end;

Procedure SetTime(Hour,Min,Sec:Byte);
Begin
 WriteCmos(4,ToBCD(Hour));
 WriteCmos(2,ToBCD(Min));
 WriteCmos(0,ToBCD(Sec));
End;

Procedure GetAlramTime(Var Hour,Min,Sec:Byte);
Begin
 Hour:=UnBCD(ReadCmos(5));
 Min:=UnBCD(ReadCmos(3));
 Sec:=UnBCD(ReadCmos(1));
end;

Procedure SetAlramTime(Hour,Min,Sec:Byte);
Begin
 WriteCmos(5,ToBCD(Hour));
 WriteCmos(3,ToBCD(Min));
 WriteCmos(1,ToBCD(Sec));
End;

Procedure GetDateTime(Var Year,Month,Day:Byte);
Begin
 Year:=UnBCD(ReadCmos(9));
 Month:=UnBCD(ReadCmos(8));
 Day:=UnBCD(ReadCmos(7));
end;

Procedure SetDateTime(Year,Month,Day:Byte);
Begin
 WriteCmos(9,ToBCD(Year));
 WriteCmos(8,ToBCD(Month));
 WriteCmos(7,ToBCD(Day));
End;

Procedure GetSRegsterA(R:RAType);
Var
 I:Byte;
Begin
 I:=ReadCmos($A);
 R.UpDate_In_Progress:=Boolean(I Shr 7);
 R.Divider:=(I Shr 4) And 7;
 R.Rate_Select:=I And $0F;
End;

Procedure GetSRegsterB(R:RBType);
Var
 I:Byte;
Begin
 I:=ReadCmos($B);
 R.SetRTCTimer:=Boolean((I Shr 7) And 1);
 R.Peridodic_Interrupt_Enable:=Boolean((I Shr 6) And 1);
 R.Alarm_Interrupt_Enable:=Boolean((I Shr 5) And 1);
 R.Update_Interrupt_Enable:=Boolean((I Shr 4) And 1);
 R.SQuare_Wave_Enable:=Boolean((I Shr 3) And 1);
 R.Binary_Enable:=Boolean((I Shr 2) And 1);
 R.Hour_24_Enable:=Boolean((I Shr 1) And 1);
 R.Summer_Time_Enable:=Boolean(I And 1);
End;

Procedure GetSRegsterC(R:RCTyep);
Var
 I:Byte;
Begin
 I:=ReadCmos($C);
 R.Alarm_Interrupt_Flag:=Boolean((I Shr 6) And 1);
 R.Periodic_Interrupt_Flag:=Boolean((I Shr 5) And 1);
 R.UpDate_Interrupt_Flag:=Boolean((I Shr 4) And 1);
End;

Procedure SCheck(R:SCheckType);
Var
 I:Byte;
Begin
 I:=ReadCmos($E);
 R.CmosPower:=Boolean((ReadCmos($A) Shr 7) And (I Shr 7));
 R.CheckSum:=Boolean((I Shr 6) And 1);
 R.System:=Boolean((I Shr 5) And 1);
 R.Ram:=Boolean((I Shr 4) And 1);
 R.C_Drive:=Boolean((I Shr 3) And 1);
 R.RTCTime:=Boolean((I Shr 2) And 1);
End;

Procedure CheckSystem(R:SystemType);
Var
 I:Byte;
Begin
 I:=ReadCmos($14);
 R.DiskDrive:=I Shr 6;
 R.VideoCard:=(I Shr 4) And 3;
 R.CoProcess:=Boolean((I Shr 1) And 1);
 R.Drive:=Boolean(I And 1);
 I:=ReadCmos($10);
 R.FDD1:=I Shr 4;
 R.FDD2:=I And $F;
 I:=Readcmos($12);
 If (I Shr 4)<$F Then R.HDD1:=I Shr 4
  Else R.HDD1:=ReadCmos($19);
 If (I And $f)<$F Then R.HDD2:=I Shr 4
  Else R.HDD2:=ReadCmos($1a);
 R.BaseRam:=ReadCmos($15)*256+ReadCmos($16);
 R.Expanded:=ReadCmos($18)*256+ReadCmos($17);
End;


Procedure Init;
Var
 I:Word;
Begin
 SetRGBPalette:=True;
 SetGrayPalette:=False;
 ConvertPalette:=False;
 NulColor:=$FF;
 LineStyle:=1;
 For I:=0 To 6 Do
  Begin
   BoxColor[I].Hi:= $0F-I;
   BoxColor[I].Med:=$07-I;
   BoxColor[I].Lo:= $08;
   BoxColor[I].Shadow:= $00;
   BoxColor[I].Back:= $07-I;
   BoxColor[I].State:=BoxOut;
  End;
 For I:=0 To 6 Do
  Begin
   BoxColor[I+7].Hi:= $0F-I;
   BoxColor[I+7].Med:=$07-I;
   BoxColor[I+7].Lo:= $08;
   BoxColor[I+7].Shadow:= $00;
   BoxColor[I+7].Back:= $07-I;
   BoxColor[I+7].State:=BoxInOut+BoxShadow+BoxThick;
  End;
End;

Procedure HanInit;
Begin
 HSFontF:=False;
 SpecialFontF:=False;
 HanjaFontF:=False;
 HanJaCodes:=0;
{ GetMem(HanJa,SizeOf(HanJaType));}
 {GetMem(SpeFont,SizeOf(SpeType));}
 GetMem(HanSpeFont,SizeOf(HSType));
 GetMem(HanFontF,SizeOf(FType));
 GetMem(HanFontS,SizeOf(SType));
 GetMem(HanFontT,SizeOf(TType));
 GetMem(EngFont,SizeOf(EType));
 RHjFont('HanJa.Fnt');
 RHSpeFont('HSpe.Fnt');
 RSpeFont('Special.Fnt');
 FontStyle.Onlyeng:=False;
 FontStyle.UseHanja:=False;
 FontStyle.Width:=1;
 FontStyle.Height:=1;
 FontStyle.Color:=$0F;
 FontStyle.BColor:=0;
 FontStyle.HanFont:=0;
 FontStyle.EngFont:=0;
 FontStyle.State:=0;
 FontStyle.LineColor:=$0A;
 LoadHan(0,@hmyfont);
 LoadEng(0,@emyfont);
End;

Procedure HanDone;
Begin
{ FreeMem(HanJa,SizeOf(HanJaType));}
{ FreeMem(SpeFont,SizeOf(SpeType));}
 FreeMem(HanSpeFont,SizeOf(HSType));
 FreeMem(HanFontF,SizeOf(FType));
 FreeMem(HanFontS,SizeOf(SType));
 FreeMem(HanFontT,SizeOf(TType));
 FreeMem(EngFont,SizeOf(EType));
End;

Begin
 Init;
End.
